"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Styled = require("./number-input.style");
var number_input_type_1 = require("./number-input.type");

var NumberInput = function (_React$Component) {
    _inherits(NumberInput, _React$Component);

    function NumberInput() {
        _classCallCheck(this, NumberInput);

        var _this = _possibleConstructorReturn(this, (NumberInput.__proto__ || Object.getPrototypeOf(NumberInput)).apply(this, arguments));

        _this.state = new number_input_type_1.State();
        _this.handleChange = function (event) {
            if (typeof _this.props.onChange === "function") {
                var value = _this.toNumber(event.currentTarget.value);
                if (value !== "") {
                    _this.props.onChange(value);
                } else {
                    _this.props.onChange(null);
                }
            }
        };
        _this.toNumber = function (value) {
            if (value === undefined || value === null) {
                return "";
            }
            if (typeof value !== "string") {
                value = value.toString();
            }
            if (value === "") {
                return "";
            }
            var numberValue = Number(value);
            if (isNaN(numberValue)) {
                numberValue = 0;
            }
            if (numberValue > _this.props.max) {
                numberValue = _this.props.max;
            }
            if (numberValue < _this.props.min) {
                numberValue = _this.props.min;
            }
            return numberValue;
        };
        return _this;
    }

    _createClass(NumberInput, [{
        key: "render",
        value: function render() {
            return React.createElement(Styled.Input, { style: this.props.style, theme: {
                    disabled: this.props.disabled
                }, value: this.toNumber(this.props.value).toString(), onChange: this.handleChange, onClick: this.props.onClick, placeholder: this.props.placeholder, disabled: this.props.disabled });
        }
    }]);

    return NumberInput;
}(React.Component);

NumberInput.defaultProps = new number_input_type_1.Props();
exports.NumberInput = NumberInput;
//# sourceMappingURL=number-input.component.js.map