"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
var Styled = require("./option.style");
var typings = require("./option.type");
var reg = function reg(input) {
    return new RegExp(input, "g");
};

var Option = function (_React$Component) {
    _inherits(Option, _React$Component);

    function Option() {
        _classCallCheck(this, Option);

        var _this = _possibleConstructorReturn(this, (Option.__proto__ || Object.getPrototypeOf(Option)).apply(this, arguments));

        _this.state = new typings.State();
        _this.handleClick = function () {
            if (_this.props.disabled) {
                return;
            }
            _this.props.onClick(_this.props.value, _this.props.children.toString(), _this.props.optChildren, _this.props.zIndex);
        };
        return _this;
    }

    _createClass(Option, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            if (this.props.value === this.props.activeValue) {
                this.props.setLabelValue(this.props.value, this.props.children.toString());
            }
        }
    }, {
        key: "render",
        value: function render() {
            if (this.props.searchValue) {
                var regex = reg(this.props.searchValue);
                if (regex.test(this.props.children.toString())) {
                    var matchedString = _.escape(this.props.children.toString()).replace(regex, "<span class=\"gaea-component-select-option-active\">" + this.props.searchValue + "</span>");
                    return React.createElement("li", { onClick: this.handleClick.bind(this), dangerouslySetInnerHTML: { __html: matchedString } });
                } else {
                    return null;
                }
            }
            return React.createElement(Styled.Container, { theme: { disabled: this.props.disabled, active: this.props.active }, onClick: this.handleClick.bind(this) }, this.props.children);
        }
    }]);

    return Option;
}(React.Component);

Option.defaultProps = new typings.Props();
exports.Option = Option;
//# sourceMappingURL=option.component.js.map