"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var _ = require("lodash");
var React = require("react");
var ReactDOM = require("react-dom");
var src_1 = require("../../../input/src");
var src_2 = require("../../../tooltip/src");
var option_group_component_1 = require("../option-group/option-group.component");
var option_component_1 = require("../option/option.component");
var Styled = require("./select.style");
var typings = require("./select.type");

var Select = function (_React$Component) {
    _inherits(Select, _React$Component);

    function Select(props) {
        _classCallCheck(this, Select);

        var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

        _this.state = new typings.State();
        _this.inputWidth = 0;
        _this.handleSelectClick = function () {
            _this.setState({
                open: !_this.state.open
            });
        };
        _this.handleClick = function (index, value, label, children) {
            var zIndex = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 1;

            if (!children) {
                var newValue = _this.state.value;
                var newCascader = _this.state.cascader;
                var deleteEndNumber = newCascader.length - zIndex + 1;
                while (deleteEndNumber > 0) {
                    newCascader.pop();
                    deleteEndNumber = deleteEndNumber - 1;
                }
                if (zIndex === 1) {
                    newValue = value;
                    _this.firstLabelValue = label;
                } else {
                    newCascader[zIndex - 2].value = value;
                    newCascader[zIndex - 2].labelValue = label;
                }
                _this.setState({
                    cascader: newCascader
                });
                var labelValue = label;
                if (_this.props.cascaderFull) {
                    var labelValueArray = [_this.firstLabelValue];
                    _this.state.cascader.forEach(function (item) {
                        labelValueArray.push(item.labelValue);
                    });
                    labelValue = labelValueArray.join(" / ");
                }
                _this.setState({
                    open: false,
                    value: newValue,
                    labelValue: labelValue
                }, function () {
                    if (_this.props.cascaderFull) {
                        var pathArray = [_this.state.value];
                        _this.state.cascader.forEach(function (item) {
                            pathArray.push(item.value);
                        });
                        if (typeof _this.props.onChange === "function") {
                            _this.props.onChange(pathArray, index);
                        }
                    } else {
                        if (typeof _this.props.onChange === "function") {
                            _this.props.onChange(value, index);
                        }
                    }
                });
            } else {
                var _newCascader = _this.state.cascader;
                if (zIndex === 1) {
                    _this.firstLabelValue = label;
                    _this.setState({
                        value: value
                    });
                } else {
                    _newCascader[zIndex - 2].value = value;
                    _newCascader[zIndex - 2].labelValue = label;
                    _this.setState({
                        cascader: _newCascader
                    });
                }
                _this.setState({
                    labelValue: ""
                });
                if (_newCascader.length === zIndex - 1) {
                    _newCascader.push({
                        value: "",
                        options: children
                    });
                } else {
                    _newCascader[zIndex - 1] = {
                        value: value,
                        options: children
                    };
                    var _deleteEndNumber = _newCascader.length - zIndex;
                    while (_deleteEndNumber > 0) {
                        _newCascader.pop();
                        _deleteEndNumber = _deleteEndNumber - 1;
                    }
                }
                _this.setState({
                    cascader: _newCascader
                });
            }
        };
        _this.handleDocumentClick = function (event) {
            if (!_this.dom.contains(event.target)) {
                _this.setState({
                    open: false
                });
            }
        };
        _this.handleSearchChange = function (value) {
            _this.setState({
                searchValue: value
            });
        };
        _this.handleSetLabelValue = function (value, labelValue) {
            _this.setState({
                value: value,
                labelValue: labelValue
            });
        };
        _this.getOptionChildren = function () {
            var chosenDropStyle = {
                display: _this.state.open ? null : "none",
                left: 0
            };
            var Children = React.Children.map(_this.props.children, function (item, index) {
                var active = false;
                if (item.props.value === _this.state.value) {
                    active = true;
                }
                if (_.isArray(item.props.children)) {
                    item.props.children.map(function (childItem) {
                        if (childItem.props.value === _this.state.value) {
                            active = true;
                        }
                    });
                }
                return React.cloneElement(item, {
                    onClick: _this.handleClick.bind(_this, index),
                    key: _this.state.optionKeyPrefix + index,
                    active: active,
                    setLabelValue: _this.handleSetLabelValue,
                    activeValue: _this.state.value,
                    searchValue: _this.state.searchValue
                });
            });
            var Search = null;
            if (_this.props.search) {
                Search = React.createElement("div", { className: "chosen-search" }, React.createElement(src_1.Input, { placeholder: "搜索..", ref: function ref(_ref) {
                        return ReactDOM.findDOMNode(_ref).focus();
                    }, onChange: _this.handleSearchChange.bind(_this) }));
            }
            return React.createElement(Styled.ChosenDrop, { style: chosenDropStyle }, Search, React.createElement(Styled.ChosenResults, null, Children));
        };
        _this.getOptionChildrenByOptions = function () {
            var chosenDropStyle = {
                display: _this.state.open ? null : "none",
                left: 0
            };
            var OptionChildren = _this.props.options.map(function (item, index) {
                return _this.getOptionItemByType(item, index, _this.state.value, 1);
            });
            var CascaderChildrens = _this.state.cascader.map(function (item, index) {
                var options = item.options.map(function (childrenItem, childrenItemIndex) {
                    return _this.getOptionItemByType(childrenItem, childrenItemIndex, item.value, index + 2);
                });
                return React.createElement(Styled.ChosenResults, { key: index }, options);
            });
            return React.createElement(Styled.ChosenDrop, { style: chosenDropStyle }, React.createElement("div", { className: "flex-option-container" }, React.createElement(Styled.ChosenResults, null, OptionChildren), CascaderChildrens));
        };
        _this.getOptionItemByType = function (item, index, activeValue) {
            var zIndex = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;

            if (item.groupValue) {
                var GroupChildren = item.children.map(function (eachItem, childIndex) {
                    return _this.getOptionItemByType(eachItem, childIndex, activeValue, zIndex);
                });
                return React.createElement(option_group_component_1.OptionGroup, { key: _this.state.optionKeyPrefix + index, ignoreChildren: true, label: item.groupValue }, GroupChildren);
            }
            var active = false;
            if (item.key === activeValue) {
                active = true;
            }
            return React.createElement(option_component_1.Option, { key: _this.state.optionKeyPrefix + index, value: item.key, onClick: _this.handleClick.bind(_this, index), active: active, zIndex: zIndex, optChildren: item.children, setLabelValue: _this.handleSetLabelValue, activeValue: _this.state.value, searchValue: _this.state.searchValue }, item.value);
        };
        _this.dropIconRender = function () {
            var classes = classNames({
                "open": _this.state.open,
                "fit-select-drop": true
            });
            return React.createElement("i", { className: classes });
        };
        return _this;
    }

    _createClass(Select, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.setState({
                value: this.props.value !== "" ? this.props.value : this.props.defaultValue
            });
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.value !== undefined) {
                this.setState({
                    value: nextProps.value,
                    optionKeyPrefix: nextProps.value
                });
            }
            if (nextProps.value === null) {
                this.setState({
                    labelValue: ""
                });
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            this.dom = ReactDOM.findDOMNode(this);
            document.addEventListener("click", this.handleDocumentClick);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            document.removeEventListener("click", this.handleDocumentClick);
        }
    }, {
        key: "render",
        value: function render() {
            var renderChosen = this.props.options.length === 0 ? this.getOptionChildren : this.getOptionChildrenByOptions;
            var extProps = {};
            if (this.props.simple) {
                extProps.label = "";
                extProps.placeholder = "";
            }
            if (this.props.search) {
                extProps.highlightLine = false;
            }
            return React.createElement(src_2.Tooltip, { type: "click", title: renderChosen, showArrow: false, uniformWidth: true }, React.createElement(src_1.Input, { onClick: this.handleSelectClick, value: this.state.labelValue, style: this.props.style }));
        }
    }]);

    return Select;
}(React.Component);

Select.defaultProps = new typings.Props();
exports.Select = Select;
//# sourceMappingURL=select.component.js.map