"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var S = require("./debug-box.style");
var debug_box_type_1 = require("./debug-box.type");
var debug_line_component_1 = require("../../tool-box/debug-line/debug-line.component");
function renderCount(count) {
    var level = 'normal';
    if (count < 5) {
        level = 'normal';
    }
    if (count >= 5 && count < 10) {
        level = 'frequently';
    }
    if (count >= 10 && count < 20) {
        level = 'warning';
    }
    if (count >= 20) {
        level = 'danger';
    }
    return React.createElement(S.RenderCount, { theme: { level: level } }, count);
}

var DebugBox = function (_React$PureComponent) {
    _inherits(DebugBox, _React$PureComponent);

    function DebugBox() {
        _classCallCheck(this, DebugBox);

        var _this = _possibleConstructorReturn(this, (DebugBox.__proto__ || Object.getPrototypeOf(DebugBox)).apply(this, arguments));

        _this.state = new debug_box_type_1.State();
        _this.restartAnimationTimeout = null;
        _this.showCountTimeout = null;
        _this.realChildDOM = undefined;
        _this.highLightBoxDOM = null;
        _this.allDebugIds = new Set();
        _this.isMouseEnter = false;
        _this.isMount = false;
        _this.setRealChildDOM = function (element) {
            _this.realChildDOM = element;
        };
        _this.addDebugId = function (debugId) {
            if (_this.allDebugIds.has(debugId)) {
                return;
            }
            if (!_this.realChildDOM) {
                return;
            }
            _this.allDebugIds.add(debugId);
            var realChildRect = _this.realChildDOM.getBoundingClientRect();
            _this.setState(function (state) {
                var newDebugIds = state.debugIds.slice();
                newDebugIds.push(debugId);
                return {
                    renderCount: state.renderCount + 1,
                    showCount: true,
                    debugIds: newDebugIds,
                    left: realChildRect.left,
                    top: realChildRect.top,
                    width: realChildRect.width,
                    height: realChildRect.height
                };
            });
            _this.highlight();
        };
        _this.renderDebug = function () {
            if (_this.state.showDetail) {
                return React.createElement(S.DebugContainer, { style: {
                        left: _this.state.left,
                        top: _this.state.top
                    } }, _this.renderDebugDetail());
            } else {
                return React.createElement(S.DebugContainer, { style: {
                        left: _this.state.left,
                        top: _this.state.top
                    } }, _this.renderDebugSimple());
            }
        };
        _this.renderDebugSimple = function () {
            if (!_this.state.showCount) {
                return null;
            }
            return React.createElement(S.CountTag, { onMouseEnter: function onMouseEnter() {
                    _this.isMouseEnter = true;
                    _this.setState({
                        showDetail: true
                    });
                } }, renderCount(_this.state.renderCount));
        };
        _this.renderDebugDetail = function () {
            if (!_this.state.showCount) {
                return null;
            }
            return React.createElement(S.DetailContainer, { onMouseLeave: function onMouseLeave() {
                    _this.isMouseEnter = false;
                    _this.setState({
                        showDetail: false
                    });
                } }, React.createElement(S.CallContainer, null, "dob rerender:\xA0", React.createElement(S.CallNumber, null, renderCount(_this.state.renderCount))), React.createElement(S.ActionScroll, null, React.createElement(S.ActionList, null, _this.renderActionList())));
        };
        _this.renderActionList = function () {
            var debugInfos = _this.props.dyDebug.debugInfoMap;
            return _this.state.debugIds.filter(function (debugId) {
                return debugId !== undefined && debugId !== null;
            }).filter(function (debugId) {
                return debugInfos.has(debugId);
            }).sort(function (left, right) {
                return right - left;
            }).map(function (debugId, index) {
                return React.createElement(debug_line_component_1.DebugLine, { onClick: function onClick() {
                        _this.props.dyDebug.event.emit('toggleActionDetail', debugId);
                    }, key: index, onMouseEnter: function onMouseEnter() {
                        _this.props.dyDebug.event.emit('focusActionDetail', debugId);
                    }, onMouseLeave: function onMouseLeave() {
                        _this.props.dyDebug.event.emit('unFocusActionDetail', debugId);
                    }, debugInfo: debugInfos.get(debugId), dyDebug: _this.props.dyDebug });
            });
        };
        _this.handleFocusDebug = function (debugId) {
            if (!_this.allDebugIds.has(debugId)) {
                return;
            }
            _this.highlight();
        };
        _this.handleUnFocusDebug = function (debugId) {
            if (!_this.allDebugIds.has(debugId)) {
                return;
            }
            _this.removeHighlight();
        };
        _this.highlight = function () {
            if (!_this.realChildDOM) {
                return;
            }
            var realChildRect = _this.realChildDOM.getBoundingClientRect();
            _this.setState({
                left: realChildRect.left,
                top: realChildRect.top,
                width: realChildRect.width,
                height: realChildRect.height
            });
            _this.highLightBoxDOM.classList.remove('dob-debug-animation');
            clearTimeout(_this.restartAnimationTimeout);
            _this.restartAnimationTimeout = setTimeout(function () {
                if (!_this.isMount) {
                    return;
                }
                _this.highLightBoxDOM.classList.add('dob-debug-animation');
                _this.removeCountLater();
            });
        };
        _this.removeHighlight = function () {
            if (!_this.realChildDOM) {
                return;
            }
            _this.highLightBoxDOM.classList.remove('dob-debug-animation');
            _this.removeCountLater(0);
        };
        _this.removeCountLater = function () {
            var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3000;

            clearTimeout(_this.showCountTimeout);
            _this.showCountTimeout = setTimeout(function () {
                if (_this.isMouseEnter) {
                    _this.removeCountLater(500);
                    return;
                }
                if (!_this.isMount) {
                    return;
                }
                _this.setState(function (state) {
                    return {
                        renderCount: 0,
                        showCount: false,
                        debugIds: []
                    };
                });
            }, timeout);
        };
        return _this;
    }

    _createClass(DebugBox, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.isMount = true;
            this.props.dyDebug.event.on('focusDebug', this.handleFocusDebug);
            this.props.dyDebug.event.on('unFocusDebug', this.handleUnFocusDebug);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.isMount = false;
            this.props.dyDebug.event.off('focusDebug', this.handleFocusDebug);
            this.props.dyDebug.event.off('unFocusDebug', this.handleUnFocusDebug);
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            return React.createElement(S.Container, null, React.createElement(S.HighLightBox, { ref: function ref(_ref) {
                    _this2.highLightBoxDOM = ReactDOM.findDOMNode(_ref);
                }, style: {
                    left: this.state.left,
                    top: this.state.top,
                    width: this.state.width,
                    height: this.state.height
                } }), this.renderDebug());
        }
    }]);

    return DebugBox;
}(React.PureComponent);

DebugBox.defaultProps = new debug_box_type_1.Props();
exports.DebugBox = DebugBox;
//# sourceMappingURL=debug-box.component.js.map