"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var PropTypes = require("prop-types");
var dob_react_1 = require("dob-react");
var debug_wrapper_type_1 = require("./debug-wrapper.type");
var isomorphic_1 = require("../utils/isomorphic");
var debug_box_component_1 = require("./debug-box/debug-box.component");

var DebugWrapper = function (_React$PureComponent) {
    _inherits(DebugWrapper, _React$PureComponent);

    function DebugWrapper() {
        _classCallCheck(this, DebugWrapper);

        var _this = _possibleConstructorReturn(this, (DebugWrapper.__proto__ || Object.getPrototypeOf(DebugWrapper)).apply(this, arguments));

        _this.state = new debug_wrapper_type_1.State();
        _this.isMount = false;
        _this.realChildDOM = undefined;
        _this.debugBox = null;
        _this.debugContainer = null;
        _this.onReRender = function (_ref) {
            var debugId = _ref.debugId;

            if (!_this.isMount) {
                return;
            }
            _this.debugBox.setRealChildDOM(_this.realChildDOM);
            _this.debugBox.addDebugId(debugId);
        };
        _this.handleMouseEnter = function () {
            if (!_this.realChildDOM) {
                return;
            }
            var rect = _this.realChildDOM.getBoundingClientRect();
        };
        _this.handleMouseLeave = function () {
            if (!_this.realChildDOM) {
                return;
            }
        };
        return _this;
    }

    _createClass(DebugWrapper, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.isMount = true;
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.isMount = false;
            if (this.realChildDOM !== null) {
                this.realChildDOM.removeEventListener('mouseenter', this.handleMouseEnter);
                this.realChildDOM.removeEventListener('mouseleave', this.handleMouseLeave);
            }
            try {
                ReactDOM.unmountComponentAtNode(this.debugContainer);
                document.querySelector('body').removeChild(this.debugContainer);
            } catch (error) {}
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var _this2 = this;

            this.debugContainer = document.createElement("div");
            this.debugContainer.style.position = 'absolute';
            document.querySelector('#' + isomorphic_1.debugContainerId).appendChild(this.debugContainer);
            ReactDOM.render(React.createElement(debug_box_component_1.DebugBox, { ref: function ref(_ref2) {
                    _this2.debugBox = _ref2;
                }, dyDebug: this.context.dyDebug }), this.debugContainer);
            if (React.Children.count(this.props.children) > 1) {
                return null;
            }
            if (!this.refs.realChilds) {
                return null;
            }
            if (this.realChildDOM === undefined) {
                this.realChildDOM = ReactDOM.findDOMNode(this.refs.realChilds) || null;
                if (this.realChildDOM !== null) {
                    this.realChildDOM.addEventListener('mouseenter', this.handleMouseEnter);
                    this.realChildDOM.addEventListener('mouseleave', this.handleMouseLeave);
                }
            }
        }
    }, {
        key: "getChildContext",
        value: function getChildContext() {
            return {
                dyDebug: this.context.dyDebug
            };
        }
    }, {
        key: "render",
        value: function render() {
            var _React$cloneElement;

            return React.cloneElement(this.props.children, (_React$cloneElement = {}, _defineProperty(_React$cloneElement, dob_react_1.globalState.handleReRender, this.onReRender), _defineProperty(_React$cloneElement, "ref", 'realChilds'), _defineProperty(_React$cloneElement, "key", 0), _React$cloneElement));
        }
    }]);

    return DebugWrapper;
}(React.PureComponent);

DebugWrapper.defaultProps = new debug_wrapper_type_1.Props();
DebugWrapper.contextTypes = {
    dyDebug: PropTypes.object
};
DebugWrapper.childContextTypes = {
    dyDebug: PropTypes.object
};
exports.DebugWrapper = DebugWrapper;
//# sourceMappingURL=debug-wrapper.component.js.map