"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Styled = require("./box-editor.style");
var typings = require("./box-editor.type");

var BoxEditor = function (_React$Component) {
    _inherits(BoxEditor, _React$Component);

    function BoxEditor() {
        _classCallCheck(this, BoxEditor);

        var _this = _possibleConstructorReturn(this, (BoxEditor.__proto__ || Object.getPrototypeOf(BoxEditor)).apply(this, arguments));

        _this.state = new typings.State();
        _this.lastX = null;
        _this.lastY = null;
        _this.currentHolding = "";
        _this.hasMouseDown = false;
        _this.init = function (props) {
            _this.setState({
                paddingLeft: props.paddingLeft,
                paddingTop: props.paddingTop,
                paddingRight: props.paddingRight,
                paddingBottom: props.paddingBottom,
                marginLeft: props.marginLeft,
                marginTop: props.marginTop,
                marginRight: props.marginRight,
                marginBottom: props.marginBottom
            });
        };
        _this.handleMouseDown = function (name, event) {
            _this.lastX = event.clientX;
            _this.lastY = event.clientY;
            _this.currentHolding = name;
            _this.hasMouseDown = true;
            _this.props.onStart();
        };
        _this.handleMouseMove = function (event) {
            var diffX = event.clientX - _this.lastX;
            var diffY = event.clientY - _this.lastY;
            switch (_this.currentHolding) {
                case "marginLeft":
                    _this.setState({
                        marginLeft: _this.state.marginLeft -= diffX
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.marginLeft);
                    break;
                case "paddingLeft":
                    _this.setState({
                        paddingLeft: _this.state.paddingLeft -= diffX
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.paddingLeft);
                    break;
                case "marginRight":
                    _this.setState({
                        marginRight: _this.state.marginRight += diffX
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.marginRight);
                    break;
                case "paddingRight":
                    _this.setState({
                        paddingRight: _this.state.paddingRight += diffX
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.paddingRight);
                    break;
                case "marginTop":
                    _this.setState({
                        marginTop: _this.state.marginTop -= diffY
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.marginTop);
                    break;
                case "paddingTop":
                    _this.setState({
                        paddingTop: _this.state.paddingTop -= diffY
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.paddingTop);
                    break;
                case "marginBottom":
                    _this.setState({
                        marginBottom: _this.state.marginBottom += diffY
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.marginBottom);
                    break;
                case "paddingBottom":
                    _this.setState({
                        paddingBottom: _this.state.paddingBottom += diffY
                    });
                    _this.props.onChange(_this.currentHolding, _this.state.paddingBottom);
                    break;
            }
            _this.lastX = event.clientX;
            _this.lastY = event.clientY;
        };
        _this.handleMouseUp = function () {
            if (!_this.hasMouseDown) {
                return;
            }
            _this.hasMouseDown = false;
            _this.props.onFinalChange(_this.currentHolding, _this.state[_this.currentHolding]);
            _this.currentHolding = "";
        };
        _this.handleChange = function (name, event) {
            _this.setState(_defineProperty({}, name, Number(event.target.value)));
            _this.props.onChange(name, Number(event.target.value));
            _this.props.onFinalChange(name, Number(event.target.value));
        };
        _this.renderTriangle = function (position, name) {
            var extendStyle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            var style = Object.assign({}, extendStyle, { width: 0, height: 0 });
            var outerStyle = {};
            var normalBorderWidth = _this.props.size / 4;
            var specialBorderWidth = _this.props.size / 5;
            var outerWidth = _this.props.size / 20;
            var outerSpace = _this.props.size / 40;
            switch (position) {
                case "left":
                    style.borderTop = normalBorderWidth + "px solid transparent";
                    style.borderBottom = normalBorderWidth + "px solid transparent";
                    style.borderRightStyle = "solid";
                    style.borderRightWidth = specialBorderWidth;
                    outerStyle.width = outerWidth;
                    break;
                case "top":
                    style.borderLeft = normalBorderWidth + "px solid transparent";
                    style.borderRight = normalBorderWidth + "px solid transparent";
                    style.borderBottomStyle = "solid";
                    style.borderBottomWidth = specialBorderWidth;
                    outerStyle.height = outerWidth;
                    break;
                case "right":
                    style.borderTop = normalBorderWidth + "px solid transparent";
                    style.borderBottom = normalBorderWidth + "px solid transparent";
                    style.borderLeftStyle = "solid";
                    style.borderLeftWidth = specialBorderWidth;
                    outerStyle.width = outerWidth;
                    break;
                case "bottom":
                    style.borderLeft = normalBorderWidth + "px solid transparent";
                    style.borderRight = normalBorderWidth + "px solid transparent";
                    style.borderTopStyle = "solid";
                    style.borderTopWidth = specialBorderWidth;
                    outerStyle.height = outerWidth;
                    break;
            }
            switch (name) {
                case "marginLeft":
                    style.marginLeft = 0;
                    break;
                case "paddingLeft":
                    style.marginLeft = -outerWidth;
                    outerStyle.marginLeft = outerSpace;
                    break;
                case "marginTop":
                    style.marginTop = 0;
                    break;
                case "paddingTop":
                    style.marginTop = -outerWidth;
                    outerStyle.marginTop = outerSpace;
                    break;
                case "marginRight":
                    style.marginLeft = -outerWidth * 3;
                    outerStyle.marginLeft = outerSpace;
                    break;
                case "paddingRight":
                    style.marginLeft = -specialBorderWidth / 2;
                    break;
                case "marginBottom":
                    style.marginTop = -outerWidth * 3;
                    outerStyle.marginTop = outerSpace;
                    break;
                case "paddingBottom":
                    style.marginTop = -specialBorderWidth / 2;
                    break;
            }
            return React.createElement(Styled.ButtonContainer, { style: outerStyle }, React.createElement(Styled.ButtonTriangle, { draggable: false, onMouseDown: _this.handleMouseDown.bind(_this, name), style: style, theme: { position: position } }));
        };
        _this.handleInputLeave = function (name) {
            if (_this.currentHolding !== "") {
                return;
            }
            var inputElement = ReactDOM.findDOMNode(_this.refs[name + "Input"]);
            inputElement.blur();
        };
        _this.handleInputEnter = function (name) {
            if (_this.currentHolding !== "") {
                return;
            }
            var inputElement = ReactDOM.findDOMNode(_this.refs[name + "Input"]);
            inputElement.focus();
            inputElement.select();
        };
        return _this;
    }

    _createClass(BoxEditor, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.init(this.props);
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            this.init(nextProps);
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            document.addEventListener("mousemove", this.handleMouseMove);
            document.addEventListener("mouseup", this.handleMouseUp);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            document.removeEventListener("mousemove", this.handleMouseMove);
            document.removeEventListener("mouseup", this.handleMouseUp);
        }
    }, {
        key: "render",
        value: function render() {
            var normalBorderWidth = this.props.size / 4;
            var specialBorderWidth = this.props.size / 7;
            var containerStyle = {
                width: this.props.size,
                height: this.props.size - this.props.size / 5
            };
            var leftStyle = {
                left: specialBorderWidth,
                top: this.props.size / 2 - normalBorderWidth - this.props.size / 10
            };
            var topStyle = {
                top: specialBorderWidth,
                left: this.props.size / 2 - normalBorderWidth
            };
            var rightStyle = {
                right: specialBorderWidth,
                top: this.props.size / 2 - normalBorderWidth - this.props.size / 10
            };
            var bottomStyle = {
                bottom: specialBorderWidth,
                left: this.props.size / 2 - normalBorderWidth
            };
            var numberOuterLeftStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                left: 0,
                top: this.props.size / 2 - specialBorderWidth / 2 - this.props.size / 10
            };
            var numberOuterTopStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                top: 0,
                left: this.props.size / 2 - specialBorderWidth / 2
            };
            var numberOuterRightStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                right: 0,
                top: this.props.size / 2 - specialBorderWidth / 2 - this.props.size / 10
            };
            var numberOuterBottomStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                bottom: 0,
                left: this.props.size / 2 - specialBorderWidth / 2
            };
            var numberInnerLeftStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                left: this.props.size / 3 - specialBorderWidth / 2,
                top: this.props.size / 2 - specialBorderWidth / 2 - this.props.size / 10
            };
            var numberInnerTopStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                top: this.props.size / 3 - specialBorderWidth / 2,
                left: this.props.size / 2 - specialBorderWidth / 2
            };
            var numberInnerRightStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                right: this.props.size / 3 - specialBorderWidth / 2,
                top: this.props.size / 2 - specialBorderWidth / 2 - this.props.size / 10
            };
            var numberInnerBottomStyle = {
                width: specialBorderWidth,
                height: specialBorderWidth,
                bottom: this.props.size / 3 - specialBorderWidth / 2,
                left: this.props.size / 2 - specialBorderWidth / 2
            };
            return React.createElement(Styled.Container, { style: containerStyle }, React.createElement(Styled.Left, { style: leftStyle }, this.renderTriangle("right", "marginLeft"), this.renderTriangle("right", "paddingLeft", { marginLeft: 5 })), React.createElement(Styled.Right, { style: rightStyle }, this.renderTriangle("left", "paddingRight"), this.renderTriangle("left", "marginRight", { marginLeft: 5 })), React.createElement(Styled.Top, { style: topStyle }, this.renderTriangle("bottom", "marginTop"), this.renderTriangle("bottom", "paddingTop", { marginTop: 5 })), React.createElement(Styled.Bottom, { style: bottomStyle }, this.renderTriangle("top", "paddingBottom"), this.renderTriangle("top", "marginBottom", { marginTop: 5 })), React.createElement(Styled.NumberBox, { style: numberOuterLeftStyle }, React.createElement(Styled.Input, { ref: "marginLeftInput", onMouseEnter: this.handleInputEnter.bind(this, "marginLeft"), onMouseLeave: this.handleInputLeave.bind(this, "marginLeft"), onChange: this.handleChange.bind(this, "marginLeft"), value: this.state.marginLeft.toString() })), React.createElement(Styled.NumberBox, { style: numberOuterTopStyle }, React.createElement(Styled.Input, { ref: "marginTopInput", onMouseEnter: this.handleInputEnter.bind(this, "marginTop"), onMouseLeave: this.handleInputLeave.bind(this, "marginTop"), onChange: this.handleChange.bind(this, "marginTop"), value: this.state.marginTop.toString() })), React.createElement(Styled.NumberBox, { style: numberOuterRightStyle }, React.createElement(Styled.Input, { ref: "marginRightInput", onMouseEnter: this.handleInputEnter.bind(this, "marginRight"), onMouseLeave: this.handleInputLeave.bind(this, "marginRight"), onChange: this.handleChange.bind(this, "marginRight"), value: this.state.marginRight.toString() })), React.createElement(Styled.NumberBox, { style: numberOuterBottomStyle }, React.createElement(Styled.Input, { ref: "marginBottomInput", onMouseEnter: this.handleInputEnter.bind(this, "marginBottom"), onMouseLeave: this.handleInputLeave.bind(this, "marginBottom"), onChange: this.handleChange.bind(this, "marginBottom"), value: this.state.marginBottom.toString() })), React.createElement(Styled.NumberBox, { style: numberInnerLeftStyle }, React.createElement(Styled.Input, { ref: "paddingLeftInput", onMouseEnter: this.handleInputEnter.bind(this, "paddingLeft"), onMouseLeave: this.handleInputLeave.bind(this, "paddingLeft"), onChange: this.handleChange.bind(this, "paddingLeft"), value: this.state.paddingLeft.toString() })), React.createElement(Styled.NumberBox, { style: numberInnerTopStyle }, React.createElement(Styled.Input, { ref: "paddingTopInput", onMouseEnter: this.handleInputEnter.bind(this, "paddingTop"), onMouseLeave: this.handleInputLeave.bind(this, "paddingTop"), onChange: this.handleChange.bind(this, "paddingTop"), value: this.state.paddingTop.toString() })), React.createElement(Styled.NumberBox, { style: numberInnerRightStyle }, React.createElement(Styled.Input, { ref: "paddingRightInput", onMouseEnter: this.handleInputEnter.bind(this, "paddingRight"), onMouseLeave: this.handleInputLeave.bind(this, "paddingRight"), onChange: this.handleChange.bind(this, "paddingRight"), value: this.state.paddingRight.toString() })), React.createElement(Styled.NumberBox, { style: numberInnerBottomStyle }, React.createElement(Styled.Input, { ref: "paddingBottomInput", onMouseEnter: this.handleInputEnter.bind(this, "paddingBottom"), onMouseLeave: this.handleInputLeave.bind(this, "paddingBottom"), onChange: this.handleChange.bind(this, "paddingBottom"), value: this.state.paddingBottom.toString() })));
        }
    }]);

    return BoxEditor;
}(React.Component);

BoxEditor.defaultProps = new typings.Props();
exports.BoxEditor = BoxEditor;
//# sourceMappingURL=box-editor.component.js.map