"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Styled = require("./tabs.style");
var typings = require("./tabs.type");
var renderTab = function renderTab(name) {
    return function (active) {
        if (!active) {
            return React.createElement("div", { className: "center-text" }, name);
        } else {
            return React.createElement("div", { className: "tab-bar-content" }, React.createElement("div", { className: "tab-bar-left" }, React.createElement("div", { className: "tab-bar-left-nav" })), name, React.createElement("div", { className: "tab-bar-right" }, React.createElement("div", { className: "tab-bar-right-nav" })));
        }
    };
};

var Tabs = function (_React$Component) {
    _inherits(Tabs, _React$Component);

    function Tabs() {
        _classCallCheck(this, Tabs);

        var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).apply(this, arguments));

        _this.state = new typings.State();
        _this.keyMapIndex = new Map();
        _this.setActive = function (value, index) {
            var titleContainer = _this.dom.getElementsByClassName("title-container")[0];
            var titleContainerRect = titleContainer.getBoundingClientRect();
            var titleItem = _this.dom.getElementsByClassName("title-item-" + index)[0];
            var titleItemRect = titleItem.getBoundingClientRect();
            var currentLeft = titleItemRect.left - titleContainerRect.left;
            _this.setState({
                activeKey: value,
                isForward: index > _this.previousTitleIndex,
                moveBarStyle: {
                    left: currentLeft,
                    right: titleContainerRect.width - currentLeft - titleItemRect.width
                }
            });
            _this.previousTitleIndex = index;
        };
        _this.handleTitleClick = function (value, index) {
            if (!_this.props.activeKey) {
                _this.setActive(value, index);
            }
            if (_this.props.onChange) {
                _this.props.onChange(value);
            }
        };
        return _this;
    }

    _createClass(Tabs, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.state = {
                activeKey: this.props.activeKey || this.props.defaultActiveKey
            };
            this.previousTitleIndex = -1;
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var _this2 = this;

            this.dom = ReactDOM.findDOMNode(this);
            var activeIndex = -1;
            React.Children.map(this.props.children, function (item, index) {
                if (_this2.state.activeKey === item.props.activeKey) {
                    activeIndex = index;
                }
            });
            this.setActive(this.state.activeKey, activeIndex);
            this.activeIndex = activeIndex;
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            if ("activeKey" in nextProps && nextProps.activeKey !== null) {
                this.setActive(nextProps.activeKey, this.keyMapIndex.get(nextProps.activeKey));
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this3 = this;

            var Title = React.Children.map(this.props.children, function (item, index) {
                var isActive = _this3.state.activeKey === item.props.activeKey;
                var titleContent = item.props.tab || item.props.tabRender(isActive);
                _this3.keyMapIndex.set(item.props.activeKey, index);
                return React.createElement(Styled.TitleItem, { onClick: _this3.handleTitleClick.bind(_this3, item.props.activeKey, index), theme: { active: isActive }, className: "title-item-" + index }, titleContent);
            });
            var Children = React.Children.map(this.props.children, function (item) {
                return React.cloneElement(item, {
                    active: _this3.state.activeKey === item.props.activeKey
                });
            });
            return React.createElement(Styled.Container, null, React.createElement(Styled.TitleContainer, null, React.createElement(Styled.MoveBar, { theme: {
                    forward: this.state.isForward,
                    backward: !this.state.isForward
                }, style: this.state.moveBarStyle }), " ", Title), React.createElement(Styled.ContentContainer, null, Children));
        }
    }]);

    return Tabs;
}(React.Component);

Tabs.defaultProps = new typings.Props();
exports.Tabs = Tabs;
//# sourceMappingURL=tabs.component.js.map