"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Styled = require("./tooltip.style");
var typings = require("./tooltip.type");

var Tooltip = function (_React$Component) {
    _inherits(Tooltip, _React$Component);

    function Tooltip() {
        _classCallCheck(this, Tooltip);

        var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).apply(this, arguments));

        _this.state = new typings.State();
        _this.showTooltipPosition = function () {
            var childrenBoundingClientRect = _this.childrenDom.getBoundingClientRect();
            var tooltipSpanDom = _this.tooltipDom.childNodes[0];
            var tooltipSpanBoundingClientRect = tooltipSpanDom.getBoundingClientRect();
            _this.setState({
                childrenLeft: childrenBoundingClientRect.left + document.body.scrollLeft,
                childrenTop: childrenBoundingClientRect.top + document.body.scrollTop,
                childrenWidth: childrenBoundingClientRect.width,
                childrenHeight: childrenBoundingClientRect.height,
                tooltipWidth: tooltipSpanBoundingClientRect.width,
                tooltipHeight: tooltipSpanBoundingClientRect.height,
                show: true
            });
        };
        _this.handleChildrenClick = function (event) {
            if (_this.props.type !== "click") {
                return;
            }
            if (!_this.state.show) {
                _this.showTooltipPosition();
            } else {
                _this.handleClose();
            }
        };
        _this.handleChildrenMouseOver = function (event) {
            if (_this.props.type !== "hover") {
                return;
            }
            _this.showTooltipPosition();
        };
        _this.handleChildrenMouseLeave = function (event) {
            if (_this.props.type !== "hover") {
                return;
            }
            _this.handleClose();
        };
        _this.handleClose = function () {
            _this.setState({
                show: false
            });
        };
        _this.setPosition = function (toolTipStyle, position) {
            var space = _this.props.showArrow ? 10 : 0;
            switch (position) {
                case "left":
                    toolTipStyle.left = _this.state.childrenLeft - _this.state.tooltipWidth - space;
                    toolTipStyle.top = _this.state.childrenTop - (_this.state.tooltipHeight / 2 - _this.state.childrenHeight / 2);
                    break;
                case "top":
                    toolTipStyle.left = _this.state.childrenLeft + _this.state.childrenWidth / 2 - _this.state.tooltipWidth / 2;
                    toolTipStyle.top = _this.state.childrenTop - _this.state.tooltipHeight - space;
                    break;
                case "right":
                    toolTipStyle.left = _this.state.childrenLeft + _this.state.childrenWidth + space;
                    toolTipStyle.top = _this.state.childrenTop - (_this.state.tooltipHeight / 2 - _this.state.childrenHeight / 2);
                    break;
                case "bottom":
                    toolTipStyle.left = _this.state.childrenLeft + _this.state.childrenWidth / 2 - _this.state.tooltipWidth / 2;
                    toolTipStyle.top = _this.state.childrenTop + _this.state.childrenHeight + space;
                    break;
            }
        };
        _this.handleDocumentClick = function (event) {
            if (_this.tooltipDom.contains(event.target)) {
                return;
            }
            if (_this.state.show) {
                _this.setState({
                    show: false
                });
            }
        };
        return _this;
    }

    _createClass(Tooltip, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            this.childrenDom = ReactDOM.findDOMNode(this.childrenRef);
            this.childrenDom.addEventListener("mouseover", this.handleChildrenMouseOver);
            this.childrenDom.addEventListener("mouseleave", this.handleChildrenMouseLeave);
            this.childrenDom.addEventListener("click", this.handleChildrenClick);
            this.tooltipDom = document.createElement("div");
            document.body.appendChild(this.tooltipDom);
            if (this.props.showShadow) {
                this.tooltipShadowDom = document.createElement("div");
                document.body.appendChild(this.tooltipShadowDom);
            }
            this.renderTooltip();
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.childrenDom.removeEventListener("mouseover", this.handleChildrenMouseOver);
            this.childrenDom.removeEventListener("mouseleave", this.handleChildrenMouseLeave);
            this.childrenDom.addEventListener("click", this.handleChildrenClick);
            document.removeEventListener("click", this.handleDocumentClick);
            document.body.removeChild(this.tooltipDom);
            if (this.props.showShadow) {
                document.body.removeChild(this.tooltipShadowDom);
            }
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
            this.renderTooltip();
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var children = React.cloneElement(React.Children.only(this.props.children), {
                ref: function ref(_ref) {
                    _this2.childrenRef = _ref;
                }
            });
            return children;
        }
    }, {
        key: "renderTooltip",
        value: function renderTooltip() {
            var _this3 = this;

            var toolTipStyle = Object.assign({}, this.props.style, { zIndex: this.props.zIndex, backgroundColor: this.props.showArrow ? "transparent" : null });
            if (this.props.uniformWidth) {
                toolTipStyle.width = this.state.childrenWidth;
                if (this.state.tooltipWidth !== toolTipStyle.width) {
                    this.setState({
                        tooltipWidth: toolTipStyle.width
                    });
                }
            }
            if (this.props.uniformHeight) {
                toolTipStyle.height = this.state.childrenHeight;
                if (this.state.tooltipHeight !== toolTipStyle.height) {
                    this.setState({
                        tooltipHeight: toolTipStyle.height
                    });
                }
            }
            if (this.props.width !== 0) {
                toolTipStyle.width = this.props.width;
            }
            if (this.props.height !== 0) {
                toolTipStyle.height = this.props.height;
            }
            var position = this.props.position;
            this.setPosition(toolTipStyle, position);
            if (toolTipStyle.left < 0) {
                this.setPosition(toolTipStyle, "right");
                position = "right";
            }
            if (toolTipStyle.left + toolTipStyle.width > window.outerWidth) {
                this.setPosition(toolTipStyle, "left");
                position = "left";
            }
            if (toolTipStyle.top < 0) {
                this.setPosition(toolTipStyle, "bottom");
                position = "bottom";
            }
            if (toolTipStyle.top + toolTipStyle.height > window.outerHeight) {
                this.setPosition(toolTipStyle, "top");
                position = "top";
            }
            if (position === "bottom" || position === "top") {
                if (toolTipStyle.left < 0) {
                    toolTipStyle.left = 0;
                }
                if (toolTipStyle.left + toolTipStyle.width > window.outerWidth) {
                    toolTipStyle.left = window.outerWidth - toolTipStyle.width;
                }
            }
            if (position === "left" || position === "right") {
                if (toolTipStyle.top < 0) {
                    toolTipStyle.top = 0;
                }
                if (toolTipStyle.top + toolTipStyle.height > window.outerHeight) {
                    toolTipStyle.top = window.outerHeight - toolTipStyle.height;
                }
            }
            var TooltipElement = React.createElement(Styled.Container, { style: toolTipStyle, theme: {
                    showArrow: this.props.showArrow,
                    active: this.state.show,
                    position: position
                } }, typeof this.props.title === "string" ? React.createElement(Styled.DefaultTitle, null, this.props.title) : this.props.title());
            var TooltipShadowElement = React.createElement(Styled.TooltipShallow, { onClick: this.handleClose, theme: { isShow: this.state.show, zIndex: this.props.shadowZIndex } });
            ReactDOM.render(TooltipElement, this.tooltipDom);
            if (this.props.showShadow) {
                ReactDOM.render(TooltipShadowElement, this.tooltipShadowDom);
            }
            setImmediate(function () {
                if (_this3.state.show) {
                    document.addEventListener("click", _this3.handleDocumentClick);
                } else {
                    document.removeEventListener("click", _this3.handleDocumentClick);
                }
            });
        }
    }]);

    return Tooltip;
}(React.Component);

Tooltip.defaultProps = new typings.Props();
exports.Tooltip = Tooltip;
//# sourceMappingURL=tooltip.component.js.map