"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Styled = require("./tree-node.style");
var typings = require("./tree-node.type");

var TreeNode = function (_React$Component) {
    _inherits(TreeNode, _React$Component);

    function TreeNode() {
        _classCallCheck(this, TreeNode);

        var _this = _possibleConstructorReturn(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).apply(this, arguments));

        _this.state = new typings.State();
        _this.handleContainerClick = function (event) {
            _this.props.onClick(event);
            if (!_this.props.toggleByArrow) {
                _this.setState({
                    showChildren: !_this.state.showChildren
                });
                if (_this.props.onToggleShow) {
                    _this.props.onToggleShow(event);
                }
            }
        };
        _this.handleArrowClick = function (event) {
            event.stopPropagation();
            _this.setState({
                showChildren: !_this.state.showChildren
            });
            if (_this.props.onToggleShow) {
                _this.props.onToggleShow(event);
            }
        };
        return _this;
    }

    _createClass(TreeNode, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.setState({
                showChildren: this.props.defaultExpendAll || this.props.showChildren
            });
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var childrenStyle = {
                display: this.state.showChildren ? "block" : null
            };
            var Children = React.Children.map(this.props.children, function (item) {
                if (item) {
                    return React.cloneElement(item, {
                        defaultExpendAll: _this2.props.defaultExpendAll,
                        toggleByArrow: _this2.props.toggleByArrow
                    });
                }
            });
            return React.createElement(Styled.Container, null, React.createElement(Styled.Title, { onClick: this.handleContainerClick.bind(this), onMouseOver: this.props.onMouseOver }, React.Children.count(this.props.children) > 0 ? React.createElement(Styled.TitleCaret, { theme: { down: this.state.showChildren }, onClick: this.handleArrowClick.bind(this) }, renderCaret()) : React.createElement(Styled.EmptyCaret, null), this.props.title || this.props.render()), React.createElement(Styled.Children, { style: childrenStyle }, Children ? Children : null));
        }
    }]);

    return TreeNode;
}(React.Component);

TreeNode.defaultProps = new typings.Props();
exports.TreeNode = TreeNode;
function renderCaret() {
    return React.createElement("svg", { viewBox: "0 0 1024 1024", width: "15", height: "15" }, React.createElement("path", { d: "M72.126714 862.823134l156.99052-398.326031L72.126714 66.179258l876.308263 398.317845L72.126714 862.823134z" }));
}
//# sourceMappingURL=tree-node.component.js.map