"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var gaea_basic_components_1 = require("gaea-basic-components");
var React = require("react");
var gaea_editor_type_1 = require("./gaea-editor.type");
var page_component_1 = require("./page/page.component");
var stores_1 = require("./stores");
var builtInPlugins = [];
var context = require.context("./plugins", true, /index\.(tsx|js)$/);
context.keys().forEach(function (key) {
    builtInPlugins.push(context(key).default);
});

var GaeaEditor = function (_React$Component) {
    _inherits(GaeaEditor, _React$Component);

    function GaeaEditor() {
        _classCallCheck(this, GaeaEditor);

        var _this = _possibleConstructorReturn(this, (GaeaEditor.__proto__ || Object.getPrototypeOf(GaeaEditor)).apply(this, arguments));

        _this.state = new gaea_editor_type_1.State();
        _this.stores = new stores_1.Store();
        _this.pluginStores = {};
        _this.handleCallback = function (_, params) {
            var func = _this.props[params.funcName];
            if (typeof func === "function") {
                func(params.data);
            }
        };
        return _this;
    }

    _createClass(GaeaEditor, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            var _this2 = this;

            builtInPlugins.concat(this.props.plugins).forEach(function (plugin) {
                _this2.stores.getStore().actions.ApplicationAction.addPlugin(plugin);
                if (plugin.actions) {
                    _this2.stores.addActions(plugin.actions);
                }
                if (plugin.stores) {
                    _this2.stores.addStores(plugin.stores);
                }
            });
            gaea_basic_components_1.default.concat(this.props.componentClasses).forEach(function (componentClass) {
                _this2.stores.getStore().actions.ApplicationAction.addComponentClass(componentClass);
            });
            this.stores.getStore().actions.EventAction.on(this.stores.getStore().stores.EventStore.emitEditorCallback, this.handleCallback);
            if (this.props.value) {
                this.stores.getStore().actions.ApplicationAction.initApplication(this.props.value);
            } else {
                this.stores.getStore().actions.ViewportAction.initViewport();
            }
            this.stores.getStore().actions.ApplicationAction.setOnComponentDragStart(this.props.onComponentDragStart);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.stores.getStore().actions.EventAction.off(this.stores.getStore().stores.EventStore.emitEditorCallback, this.handleCallback);
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(dob_react_1.Provider, Object.assign({}, this.stores.getStore()), React.createElement(page_component_1.default, { componentClasses: this.props.componentClasses }));
        }
    }]);

    return GaeaEditor;
}(React.Component);

GaeaEditor.defaultProps = new gaea_editor_type_1.Props();
exports.default = GaeaEditor;
//# sourceMappingURL=gaea-editor.component.js.map