"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var _ = require("lodash");
var React = require("react");
var ReactDOM = require("react-dom");
var dom_1 = require("../../../utils/dom");
var Style = require("./edit-helper.style");
var edit_helper_type_1 = require("./edit-helper.type");
Style.injectGlob();

var EditHelper = function (_React$Component) {
    _inherits(EditHelper, _React$Component);

    function EditHelper() {
        _classCallCheck(this, EditHelper);

        var _this = _possibleConstructorReturn(this, (EditHelper.__proto__ || Object.getPrototypeOf(EditHelper)).apply(this, arguments));

        _this.state = new edit_helper_type_1.State();
        _this.forceRender = function () {
            _this.forceUpdate();
        };
        _this.handleMouseOver = function (event) {
            event.stopPropagation();
            _this.props.actions.EventAction.emit(_this.props.stores.EventStore.mouseHoveringComponent, {
                instanceKey: _this.props.instanceKey,
                type: "instance"
            });
            _this.props.actions.ViewportAction.setCurrentHoverInstanceKey(_this.props.instanceKey);
        };
        _this.handleClick = function (event) {
            event.stopPropagation();
            var setting = _this.props.actions.ApplicationAction.getSettingByInstance(_this.instanceInfo);
            _this.props.actions.ViewportAction.setCurrentEditInstanceKey(_this.props.instanceKey);
        };
        _this.setLayoutClassIfCanDragIn = function () {
            if (_this.setting.isContainer && _this.instanceInfo.parentInstanceKey !== null) {
                dom_1.addClass(_this.domInstance, "gaea-container");
            }
        };
        return _this;
    }

    _createClass(EditHelper, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.instanceInfo = this.props.stores.ViewportStore.instances.get(this.props.instanceKey);
            this.componentClass = this.props.actions.ApplicationAction.getComponentClassByKey(this.instanceInfo.gaeaKey);
            this.setting = this.props.actions.ApplicationAction.getSettingByInstance(this.instanceInfo);
            this.defaultProps = this.props.actions.ApplicationAction.getDefaultPropsByInstance(this.instanceInfo);
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            this.domInstance = ReactDOM.findDOMNode(this.wrappedInstance);
            this.domInstance.addEventListener("mouseover", this.handleMouseOver);
            this.domInstance.addEventListener("click", this.handleClick);
            this.setLayoutClassIfCanDragIn();
            dom_1.addClass(this.domInstance, "gaea-draggable");
            this.props.actions.ViewportAction.setDomInstance(this.props.instanceKey, this.domInstance);
            if (this.setting.isContainer) {
                this.props.actions.ViewportAction.registerInnerDrag(this.props.instanceKey, this.domInstance, {
                    draggable: ".gaea-draggable"
                });
            }
            this.props.actions.EventAction.on(this.props.stores.EventStore.instanceUpdate + "." + this.props.instanceKey, this.forceRender);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.props.actions.EventAction.off(this.props.stores.EventStore.instanceUpdate + "." + this.props.instanceKey, this.forceRender);
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var childs = null;
            if (this.setting.isContainer) {
                childs = this.instanceInfo.childs.map(function (childKey) {
                    return React.createElement(ConnectedEditHelper, { key: childKey, instanceKey: childKey });
                });
            }
            var wrapProps = _.merge({}, this.defaultProps, Object.assign({}, this.instanceInfo.data.props), {
                ref: function ref(_ref) {
                    _this2.wrappedInstance = _ref;
                }
            });
            return React.createElement(this.componentClass, wrapProps, childs);
        }
    }]);

    return EditHelper;
}(React.Component);

EditHelper.defaultProps = new edit_helper_type_1.Props();
var ConnectedEditHelper = dob_react_1.Connect(EditHelper);
exports.default = ConnectedEditHelper;
//# sourceMappingURL=edit-helper.component.js.map