"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var _ = require("lodash");
var React = require("react");
var src_1 = require("../../components/icon/src");
var Styled = require("./index.style");
var index_type_1 = require("./index.type");
var MainToolEditorManager = function (_React$Component) {
    _inherits(MainToolEditorManager, _React$Component);

    function MainToolEditorManager() {
        _classCallCheck(this, MainToolEditorManager);

        var _this = _possibleConstructorReturn(this, (MainToolEditorManager.__proto__ || Object.getPrototypeOf(MainToolEditorManager)).apply(this, arguments));

        _this.state = new index_type_1.State();
        _this.handleToggleValueType = function (realField) {
            var isVariable = _this.props.actions.ViewportAction.instanceFieldIsVariable(_this.props.stores.ViewportStore.currentEditInstanceKey, realField);
            if (isVariable) {
                _this.props.actions.ViewportAction.instanceDisableVariable(_this.props.stores.ViewportStore.currentEditInstanceKey, realField);
            } else {
                _this.props.actions.ViewportAction.instanceEnableVariable(_this.props.stores.ViewportStore.currentEditInstanceKey, realField);
            }
            _this.forceUpdate();
        };
        return _this;
    }

    _createClass(MainToolEditorManager, [{
        key: "render",
        value: function render() {
            var _this2 = this;

            var instanceKey = this.props.stores.ViewportStore.currentEditInstanceKey;
            if (!this.props.stores.ViewportStore.instances.has(instanceKey)) {
                return null;
            }
            this.instanceInfo = this.props.stores.ViewportStore.instances.get(instanceKey);
            var editors = this.props.editors || this.props.actions.ApplicationAction.getSettingByInstance(this.instanceInfo).editors || [];
            var EditorFields = null;
            if (typeof editors === "string") {
                return React.createElement(Styled.EditorContainer, null, this.props.actions.ApplicationAction.loadPluginByPosition("mainToolEditorType" + _.upperFirst(_.camelCase(editors)), {
                    editor: editors,
                    realField: this.props.realField
                }));
            } else {
                EditorFields = editors.map(function (editor, index) {
                    if (typeof editor === "string") {
                        return React.createElement(Styled.TabTitle, { key: index }, editor);
                    } else {
                        var realField = _this2.props.realField === "" ? editor.field : _this2.props.realField + "." + editor.field;
                        var child = null;
                        var isVariable = _this2.props.actions.ViewportAction.instanceFieldIsVariable(_this2.props.stores.ViewportStore.currentEditInstanceKey, realField);
                        if (!isVariable) {
                            child = _this2.props.actions.ApplicationAction.loadPluginByPosition("mainToolEditorType" + _.upperFirst(_.camelCase(editor.type)), {
                                editor: editor,
                                realField: realField
                            });
                        } else {
                            child = _this2.props.actions.ApplicationAction.loadPluginByPosition("mainToolEditorVariable", {
                                editor: editor,
                                realField: realField
                            });
                        }
                        var isObjectType = editor.type === "array" || editor.type === "object";
                        return React.createElement(Styled.EditorContainer, { key: index, theme: { isObjectType: isObjectType && !isVariable } }, React.createElement(Styled.Label, { theme: { isObjectType: isObjectType && !isVariable } }, React.createElement("span", null, editor.label)), React.createElement(Styled.EditorBoxContainer, null, child), React.createElement(Styled.Variable, { theme: { isVariable: isVariable }, onClick: _this2.handleToggleValueType.bind(_this2, realField) }, isVariable ? React.createElement(src_1.default, { type: "database", size: 14 }) : React.createElement(src_1.default, { type: "keybroad" })));
                    }
                });
            }
            return React.createElement("div", null, EditorFields);
        }
    }]);

    return MainToolEditorManager;
}(React.Component);
MainToolEditorManager.defaultProps = new index_type_1.Props();
MainToolEditorManager = __decorate([dob_react_1.Connect], MainToolEditorManager);
exports.default = {
    position: "mainToolEditorManager",
    class: MainToolEditorManager
};
//# sourceMappingURL=index.js.map