"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var React = require("react");
var src_1 = require("../../components/number-input/src");
var Styled = require("./index.style");
var index_type_1 = require("./index.type");
var parseInputToOutRange = function parseInputToOutRange(value, inputRange, outputRange) {
    if (value === undefined || value === null) {
        return null;
    }
    value = Number(value);
    if (inputRange[0] === outputRange[0] && inputRange[1] === outputRange[1]) {
        return value;
    }
    if (value >= inputRange[0] && value <= inputRange[1]) {
        var percentage = (value - inputRange[0]) / (inputRange[1] - inputRange[0]);
        var outputLength = (outputRange[1] - outputRange[0]) * percentage;
        value = outputLength + outputRange[0];
    }
    return value;
};
var MainToolEditorNumber = function (_React$Component) {
    _inherits(MainToolEditorNumber, _React$Component);

    function MainToolEditorNumber() {
        _classCallCheck(this, MainToolEditorNumber);

        var _this = _possibleConstructorReturn(this, (MainToolEditorNumber.__proto__ || Object.getPrototypeOf(MainToolEditorNumber)).apply(this, arguments));

        _this.state = new index_type_1.State();
        _this.handleChange = function (value) {
            value = parseInputToOutRange(value, _this.numberData.inputRange, _this.numberData.outputRange);
            _this.props.actions.ViewportAction.setInstanceProps(_this.props.stores.ViewportStore.currentEditInstanceKey, _this.props.realField, value);
        };
        _this.handleSliderChange = function (event) {
            var value = Number(event.currentTarget.value);
            _this.handleChange(value);
        };
        return _this;
    }

    _createClass(MainToolEditorNumber, [{
        key: "render",
        value: function render() {
            if (!this.props.stores.ViewportStore.instances.has(this.props.stores.ViewportStore.currentEditInstanceKey)) {
                return null;
            }
            this.instanceInfo = this.props.stores.ViewportStore.instances.get(this.props.stores.ViewportStore.currentEditInstanceKey);
            var currentValue = this.props.actions.ViewportAction.getInstanceProps(this.props.stores.ViewportStore.currentEditInstanceKey, this.props.realField);
            this.numberData = Object.assign({ useSlider: false, step: 1, inputRange: [-9999999, 9999999] }, this.props.editor.data || {});
            if (this.numberData.inputRange && !this.numberData.outputRange) {
                this.numberData.outputRange = this.numberData.inputRange.slice();
            }
            currentValue = parseInputToOutRange(currentValue, this.numberData.outputRange, this.numberData.inputRange);
            return React.createElement(Styled.Container, null, currentValue !== null && this.numberData.useSlider && React.createElement("input", { min: this.numberData.inputRange[0], max: this.numberData.inputRange[1], step: this.numberData.step, value: currentValue || 0, onChange: this.handleSliderChange, type: "range" }), React.createElement(src_1.NumberInput, { value: currentValue, onChange: this.handleChange, min: this.numberData.inputRange[0], max: this.numberData.inputRange[1] }));
        }
    }]);

    return MainToolEditorNumber;
}(React.Component);
MainToolEditorNumber.defaultProps = new index_type_1.Props();
MainToolEditorNumber = __decorate([dob_react_1.Connect], MainToolEditorNumber);
exports.default = {
    position: "mainToolEditorTypeNumber",
    class: MainToolEditorNumber
};
//# sourceMappingURL=index.js.map