"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var React = require("react");
var ReactDOM = require("react-dom");
var src_1 = require("../../../components/tree/src");
var Styled = require("./tree-node.style");
var typings = require("./tree-node.type");

var CustomTreeNode = function (_React$Component) {
    _inherits(CustomTreeNode, _React$Component);

    function CustomTreeNode() {
        _classCallCheck(this, CustomTreeNode);

        var _this = _possibleConstructorReturn(this, (CustomTreeNode.__proto__ || Object.getPrototypeOf(CustomTreeNode)).apply(this, arguments));

        _this.state = new typings.State();
        _this.health = 1;
        _this.updateDom = function () {
            _this.props.actions.TreeAction.addTreeDom(_this.props.instanceKey, ReactDOM.findDOMNode(_this));
        };
        _this.handleRenderTitle = function () {
            var eventTag = null;
            return React.createElement(Styled.ItemContainer, null, React.createElement("div", { className: "title" }, _this.setting.name, eventTag));
        };
        _this.handleMouseOver = function (event) {
            event.stopPropagation();
            _this.props.actions.ViewportAction.setCurrentHoverInstanceKey(_this.props.instanceKey);
        };
        _this.handleClick = function (event) {
            event.stopPropagation();
            _this.props.actions.ViewportAction.setCurrentEditInstanceKey(_this.props.instanceKey);
        };
        return _this;
    }

    _createClass(CustomTreeNode, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            this.instanceInfo = this.props.stores.ViewportStore.instances.get(this.props.instanceKey);
            this.componentClass = this.props.actions.ApplicationAction.getComponentClassByKey(this.instanceInfo.gaeaKey);
            this.setting = this.props.actions.ApplicationAction.getSettingByInstance(this.instanceInfo);
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            this.health++;
            this.props.actions.TreeAction.addTreeDom(this.props.instanceKey, ReactDOM.findDOMNode(this));
            if (this.setting.isContainer) {
                this.props.actions.ViewportAction.registerInnerDrag(this.props.instanceKey, ReactDOM.findDOMNode(this).getElementsByClassName("childs-container")[0], "gaea-tree-container");
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.health--;
            if (this.health === 0) {
                this.props.actions.TreeAction.removeTreeDom(this.props.instanceKey);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var childs = null;
            if (this.setting.isContainer && this.instanceInfo.childs) {
                childs = this.instanceInfo.childs.map(function (childKey) {
                    return React.createElement(ConnectedCustomTreeNode, { key: childKey, instanceKey: childKey });
                });
            }
            var childProps = {
                render: this.handleRenderTitle,
                defaultExpendAll: true,
                toggleByArrow: true,
                onMouseOver: this.handleMouseOver,
                onClick: this.handleClick
            };
            return React.createElement(src_1.TreeNode, childProps, childs);
        }
    }]);

    return CustomTreeNode;
}(React.Component);

CustomTreeNode.defaultProps = new typings.Props();
var ConnectedCustomTreeNode = dob_react_1.Connect(CustomTreeNode);
exports.default = ConnectedCustomTreeNode;
//# sourceMappingURL=tree-node.component.js.map