"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var React = require("react");
var src_1 = require("../../../components/icon/src");
var src_2 = require("../../../components/tree/src");
var Styled = require("./tree-node.style");
var typings = require("./tree-node.type");

var CustomTreeNode = function (_React$Component) {
    _inherits(CustomTreeNode, _React$Component);

    function CustomTreeNode() {
        _classCallCheck(this, CustomTreeNode);

        var _this = _possibleConstructorReturn(this, (CustomTreeNode.__proto__ || Object.getPrototypeOf(CustomTreeNode)).apply(this, arguments));

        _this.state = new typings.State();
        _this.handleClick = function () {
            if (_this.props.pageKey === _this.props.stores.ApplicationStore.currentCreatedPageKey) {
                return;
            }
            if (_this.props.pageKey === _this.props.stores.ApplicationStore.currentViewportPageKey) {
                return;
            }
            if (_this.pageInfo.type === "page") {
                var fullInformation = _this.props.stores.ViewportStore.currentFullInformation;
                _this.props.stores.ApplicationStore.pageInstances.set(_this.props.stores.ApplicationStore.currentViewportPageKey, fullInformation);
                _this.props.actions.ApplicationAction.resetApplication();
                _this.props.actions.ApplicationAction.setLeftTool("page");
                if (_this.props.stores.ApplicationStore.pageInstances.has(_this.props.pageKey)) {
                    _this.props.actions.ViewportAction.resetViewport(_this.props.stores.ApplicationStore.pageInstances.get(_this.props.pageKey));
                } else {
                    _this.props.actions.ViewportAction.clearViewport();
                    _this.props.actions.ViewportAction.initViewport();
                }
                _this.props.actions.ApplicationAction.changeCurrentViewportPageKey(_this.props.pageKey);
            }
        };
        _this.handleEdit = function (event) {
            event.stopPropagation();
            _this.props.actions.ApplicationAction.RemoveCreatingPage();
            _this.props.actions.ApplicationAction.setCurrentEditPageKey(_this.props.pageKey);
            var pageInfo = _this.props.stores.ApplicationStore.pages.get(_this.props.pageKey);
            if (pageInfo.type === "folder") {
                _this.props.actions.ApplicationAction.setRightTool("addFolder");
            } else {
                _this.props.actions.ApplicationAction.setRightTool("addPage");
            }
        };
        return _this;
    }

    _createClass(CustomTreeNode, [{
        key: "render",
        value: function render() {
            var _this2 = this;

            this.pageInfo = this.props.stores.ApplicationStore.pages.get(this.props.pageKey);
            if (!this.pageInfo) {
                return null;
            }
            var childs = null;
            if (this.pageInfo.type === "folder") {
                childs = this.pageInfo.childs.map(function (childKey) {
                    return React.createElement(ConnectedTreeNode, { key: childKey, pageKey: childKey });
                });
            }
            var pageName = this.pageInfo.name;
            var currentCreatedPageKey = this.props.stores.ApplicationStore.currentCreatedPageKey;
            var currentViewportPageKey = this.props.stores.ApplicationStore.currentViewportPageKey;
            var currentEditPageKey = this.props.stores.ApplicationStore.currentEditPageKey;
            var childProps = {
                render: function render() {
                    return React.createElement(Styled.Content, { theme: { editted: currentEditPageKey === _this2.props.pageKey } }, React.createElement(Styled.Title, { theme: { isHome: _this2.pageInfo.isHomePage } }, pageName === "" ? React.createElement(Styled.UnNamed, null, "<\u672A\u547D\u540D>") : pageName), React.createElement(Styled.RightContainer, null, currentViewportPageKey === _this2.props.pageKey && React.createElement(Styled.InUseTag, null, "\u4F7F\u7528\u4E2D"), currentCreatedPageKey !== _this2.props.pageKey && React.createElement(Styled.Setting, { onClick: _this2.handleEdit }, React.createElement(src_1.default, { type: "setting", size: 15 }))));
                },
                defaultExpendAll: true,
                toggleByArrow: true,
                onClick: this.handleClick
            };
            return React.createElement(Styled.Container, null, React.createElement(src_2.TreeNode, childProps, childs));
        }
    }]);

    return CustomTreeNode;
}(React.Component);

CustomTreeNode.defaultProps = new typings.Props();
var ConnectedTreeNode = dob_react_1.Connect(CustomTreeNode);
exports.default = ConnectedTreeNode;
//# sourceMappingURL=tree-node.component.js.map