"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_react_1 = require("dob-react");
var React = require("react");
var Styled = require("./index.style");
var typings = require("./index.type");
var ViewportGuideline = function (_React$Component) {
    _inherits(ViewportGuideline, _React$Component);

    function ViewportGuideline() {
        _classCallCheck(this, ViewportGuideline);

        var _this = _possibleConstructorReturn(this, (ViewportGuideline.__proto__ || Object.getPrototypeOf(ViewportGuideline)).apply(this, arguments));

        _this.state = new typings.State();
        _this.handleViewportUpdated = function () {
            _this.forceUpdate();
            _this.updateTimeout();
        };
        _this.updateTimeout = function () {
            if (_this.timeOut) {
                clearTimeout(_this.timeOut);
            }
            _this.timeOut = setInterval(function () {
                if (_this.props.stores.ViewportStore.currentDragInfo !== null) {
                    return null;
                }
                if (_this.props.stores.ViewportStore.currentHoverInstanceKey === null) {
                    return null;
                }
                _this.forceUpdate();
            }, 200);
        };
        return _this;
    }

    _createClass(ViewportGuideline, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            this.props.actions.EventAction.on(this.props.stores.EventStore.viewportUpdated, this.handleViewportUpdated);
            this.updateTimeout();
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.props.actions.EventAction.off(this.props.stores.EventStore.viewportUpdated, this.handleViewportUpdated);
            clearTimeout(this.timeOut);
        }
    }, {
        key: "render",
        value: function render() {
            if (this.props.stores.ViewportStore.currentDragInfo !== null) {
                return null;
            }
            if (this.props.stores.ViewportStore.currentHoverInstanceKey === null) {
                return null;
            }
            var targetBoundingClientRect = this.props.stores.ViewportStore.instanceDoms.get(this.props.stores.ViewportStore.currentHoverInstanceKey).getBoundingClientRect();
            var viewportBoundingClientRect = this.props.stores.ViewportStore.viewportDOM.getBoundingClientRect();
            var style = {
                width: targetBoundingClientRect.width - 1,
                height: targetBoundingClientRect.height - 1,
                top: targetBoundingClientRect.top - viewportBoundingClientRect.top,
                left: targetBoundingClientRect.left - viewportBoundingClientRect.left
            };
            return React.createElement(Styled.Container, { style: style });
        }
    }]);

    return ViewportGuideline;
}(React.Component);
ViewportGuideline.defaultProps = new typings.Props();
ViewportGuideline = __decorate([dob_react_1.Connect], ViewportGuideline);
exports.default = {
    position: "viewport",
    class: ViewportGuideline
};
//# sourceMappingURL=index.js.map