"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = undefined && undefined.__metadata || function (k, v) {
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_1 = require("dob");
var _ = require("lodash");
var LZString = require("lz-string");
var React = require("react");
var store_1 = require("../viewport/store");
var store_2 = require("./store");

var ApplicationAction = function () {
    function ApplicationAction() {
        _classCallCheck(this, ApplicationAction);
    }

    _createClass(ApplicationAction, [{
        key: "addPlugin",
        value: function addPlugin(plugin) {
            this.store.plugins.push(plugin);
        }
    }, {
        key: "loadPluginByPosition",
        value: function loadPluginByPosition(position, props) {
            return this.store.plugins.filter(function (plugin) {
                return plugin.position === position;
            }).map(function (plugin, index) {
                return React.createElement(plugin.class, Object.assign({ key: index }, props));
            });
        }
    }, {
        key: "addComponentClass",
        value: function addComponentClass(componentClass) {
            var gaeaKey = componentClass.defaultProps.gaeaSetting.key;
            this.store.componentClasses.set(gaeaKey, componentClass);
            this.setComponentSetting(gaeaKey, componentClass.defaultProps.gaeaSetting);
            this.setComponentDefaultProps(gaeaKey, componentClass.defaultProps);
        }
    }, {
        key: "setComponentSetting",
        value: function setComponentSetting(gaeaOrPreKey, setting) {
            if (!this.store.componentSetting.has(gaeaOrPreKey)) {
                this.store.componentSetting.set(gaeaOrPreKey, setting);
            } else {
                var prevSetting = this.store.componentSetting.get(gaeaOrPreKey);
                Object.assign(prevSetting, setting);
            }
        }
    }, {
        key: "setComponentDefaultProps",
        value: function setComponentDefaultProps(gaeaOrPreKey, defaultProps) {
            if (!this.store.componentDefaultProps.has(gaeaOrPreKey)) {
                this.store.componentDefaultProps.set(gaeaOrPreKey, defaultProps);
            } else {
                var prevDefaultProps = this.store.componentDefaultProps.get(gaeaOrPreKey);
                Object.assign(prevDefaultProps, defaultProps);
            }
        }
    }, {
        key: "getComponentClassByKey",
        value: function getComponentClassByKey(gaeaKey) {
            return this.store.componentClasses.get(gaeaKey);
        }
    }, {
        key: "setPreview",
        value: function setPreview(isPreview) {
            this.store.isPreview = isPreview;
        }
    }, {
        key: "setLeftTool",
        value: function setLeftTool(name) {
            this.store.leftTool = name;
        }
    }, {
        key: "setRightTool",
        value: function setRightTool(name) {
            this.store.rightTool = name;
        }
    }, {
        key: "createModal",
        value: function createModal(config, renderContent) {
            this.store.modalTitle = config.title;
            this.store.modalContentRender = renderContent;
            this.store.isShowModal = true;
        }
    }, {
        key: "closeModal",
        value: function closeModal() {
            this.store.isShowModal = false;
            this.store.modalTitle = null;
            this.store.modalContentRender = null;
        }
    }, {
        key: "renderModalContent",
        value: function renderModalContent() {
            if (typeof this.store.modalContentRender === "function") {
                return this.store.modalContentRender(this.closeModal);
            } else {
                return null;
            }
        }
    }, {
        key: "createNewPageKey",
        value: function createNewPageKey() {
            return _.uniqueId("gaea_page_");
        }
    }, {
        key: "createNewPage",
        value: function createNewPage(isFolder) {
            var pageKey = this.createNewPageKey();
            this.store.currentCreatedPageKey = pageKey;
            this.store.currentEditPageKey = pageKey;
            if (isFolder) {
                this.store.pages.set(pageKey, {
                    type: "folder",
                    name: "",
                    path: "",
                    parentKey: null,
                    childs: []
                });
            } else {
                this.store.pages.set(pageKey, {
                    type: "page",
                    name: "",
                    path: "",
                    parentKey: null
                });
            }
            this.store.rootPageKeys.push(pageKey);
            return pageKey;
        }
    }, {
        key: "createHomePage",
        value: function createHomePage() {
            var pageKey = this.createNewPageKey();
            this.store.pages.set(pageKey, {
                type: "page",
                name: "首页",
                path: "",
                parentKey: null,
                isHomePage: true
            });
            this.store.rootPageKeys.push(pageKey);
            return pageKey;
        }
    }, {
        key: "setCurrentEditPageKey",
        value: function setCurrentEditPageKey(pageKey) {
            this.store.currentEditPageKey = pageKey;
        }
    }, {
        key: "RemoveCreatingPage",
        value: function RemoveCreatingPage() {
            if (this.store.currentCreatedPageKey !== null) {
                this.removePage(this.store.currentCreatedPageKey);
            }
            this.store.currentCreatedPageKey = null;
            this.store.currentEditPageKey = null;
        }
    }, {
        key: "removePage",
        value: function removePage(pageKey) {
            var pageInfo = this.store.pages.get(pageKey);
            if (pageInfo.parentKey !== null) {
                var parentPage = this.store.pages.get(pageInfo.parentKey);
                var existIndex = parentPage.childs.findIndex(function (childKey) {
                    return childKey === pageKey;
                });
                parentPage.childs.splice(existIndex, 1);
            }
            if (!pageInfo.parentKey) {
                var _existIndex = this.store.rootPageKeys.findIndex(function (rootPageKey) {
                    return rootPageKey === pageKey;
                });
                this.store.rootPageKeys.splice(_existIndex, 1);
            }
            this.store.pages.delete(pageKey);
        }
    }, {
        key: "changePageName",
        value: function changePageName(pageKey, pageName) {
            var pageInfo = this.store.pages.get(pageKey);
            pageInfo.name = pageName;
        }
    }, {
        key: "changePagePath",
        value: function changePagePath(pageKey, pagePath) {
            var pageInfo = this.store.pages.get(pageKey);
            pageInfo.path = pagePath;
        }
    }, {
        key: "changePageParentKey",
        value: function changePageParentKey(pageKey, parentKey) {
            var pageInfo = this.store.pages.get(pageKey);
            if (pageInfo.parentKey !== null) {
                var preParentInfo = this.store.pages.get(pageInfo.parentKey);
                var existIndex = preParentInfo.childs.findIndex(function (childKey) {
                    return childKey === pageKey;
                });
                preParentInfo.childs.splice(existIndex, 1);
                if (parentKey === null) {
                    this.store.rootPageKeys.push(pageKey);
                }
            } else {
                if (parentKey !== null) {
                    var _existIndex2 = this.store.rootPageKeys.findIndex(function (rootPageKey) {
                        return rootPageKey === pageKey;
                    });
                    this.store.rootPageKeys.splice(_existIndex2, 1);
                }
            }
            pageInfo.parentKey = parentKey;
            var nextParentInfo = this.store.pages.get(parentKey);
            nextParentInfo.childs.push(pageKey);
        }
    }, {
        key: "confirmCreatePage",
        value: function confirmCreatePage() {
            this.store.currentCreatedPageKey = null;
            this.store.currentEditPageKey = null;
        }
    }, {
        key: "getPageAllChilds",
        value: function getPageAllChilds(pageKey) {
            var _this = this;

            var getAllChilds = function getAllChilds(currentPageKey) {
                var currentPageInfo = _this.store.pages.get(currentPageKey);
                if (currentPageInfo.type !== "folder") {
                    return [];
                }
                var childs = currentPageInfo.childs.slice();
                currentPageInfo.childs.forEach(function (eachChild) {
                    childs = childs.concat(getAllChilds(eachChild));
                });
                return childs;
            };
            return getAllChilds(pageKey);
        }
    }, {
        key: "changeCurrentViewportPageKey",
        value: function changeCurrentViewportPageKey(pageKey) {
            this.store.currentViewportPageKey = pageKey;
        }
    }, {
        key: "initApplication",
        value: function initApplication(value) {
            var _this2 = this;

            var info = JSON.parse(LZString.decompressFromBase64(value));
            this.store.rootPageKeys = info.rootPageKeys;
            this.store.persistenceData = info.persistenceData || {};
            Object.keys(info.pages).forEach(function (pageKey) {
                _this2.store.pages.set(pageKey, info.pages[pageKey]);
            });
            info.instancesArray.forEach(function (instanceInfo) {
                _this2.store.pageInstances.set(instanceInfo.pageKey, instanceInfo.instances);
            });
            var homePageKey = null;
            this.store.pages.forEach(function (page, pageKey) {
                if (page.isHomePage) {
                    homePageKey = pageKey;
                }
            });
            var homeInstances = this.store.pageInstances.get(homePageKey);
            Object.keys(homeInstances).forEach(function (instanceKey) {
                _this2.viewportStore.instances.set(instanceKey, homeInstances[instanceKey]);
                if (homeInstances[instanceKey].parentInstanceKey === null) {
                    _this2.viewportStore.rootInstanceKey = instanceKey;
                }
            });
            this.store.currentViewportPageKey = homePageKey;
        }
    }, {
        key: "resetApplication",
        value: function resetApplication() {
            this.store.isPreview = false;
            this.store.isShowModal = false;
            this.store.leftTool = null;
            this.store.rightTool = null;
            this.store.currentCreatedPageKey = null;
            this.store.currentEditPageKey = null;
        }
    }, {
        key: "getAllInformation",
        value: function getAllInformation() {
            var fullInformation = this.viewportStore.currentFullInformation;
            this.store.pageInstances.set(this.store.currentViewportPageKey, fullInformation);
            var pages = {};
            this.store.pages.forEach(function (pageInfo, pageKey) {
                pages[pageKey] = pageInfo;
            });
            var instancesArray = [];
            Array.from(this.store.pageInstances).forEach(function (_ref, index) {
                var _ref2 = _slicedToArray(_ref, 2),
                    pageKey = _ref2[0],
                    instances = _ref2[1];

                instancesArray.push({
                    pageKey: pageKey,
                    instances: Object.assign({}, instances)
                });
            });
            return JSON.parse(JSON.stringify({
                pages: pages,
                instancesArray: instancesArray,
                rootPageKeys: this.store.rootPageKeys,
                persistenceData: this.store.persistenceData
            }));
        }
    }, {
        key: "getFullInformationGzipped",
        value: function getFullInformationGzipped() {
            return LZString.compressToBase64(JSON.stringify(this.getAllInformation()));
        }
    }, {
        key: "setPreComponent",
        value: function setPreComponent(gaeaKey, setting) {
            if (!this.store.preComponents.has(gaeaKey)) {
                this.store.preComponents.set(gaeaKey, [setting]);
            } else {
                var settings = this.store.preComponents.get(gaeaKey);
                settings.push(setting);
            }
        }
    }, {
        key: "getSettingByInstance",
        value: function getSettingByInstance(instance) {
            if (this.store.componentSetting.has(instance.preGaeaKey)) {
                return this.store.componentSetting.get(instance.preGaeaKey);
            } else {
                return this.store.componentSetting.get(instance.gaeaKey);
            }
        }
    }, {
        key: "getDefaultPropsByInstance",
        value: function getDefaultPropsByInstance(instance) {
            if (this.store.componentDefaultProps.has(instance.preGaeaKey)) {
                return this.store.componentDefaultProps.get(instance.preGaeaKey);
            } else {
                return this.store.componentDefaultProps.get(instance.gaeaKey);
            }
        }
    }, {
        key: "setPersistenceData",
        value: function setPersistenceData(key, value) {
            this.store.persistenceData[key] = value;
        }
    }, {
        key: "getPersistenceData",
        value: function getPersistenceData(key) {
            return this.store.persistenceData[key];
        }
    }, {
        key: "setOnComponentDragStart",
        value: function setOnComponentDragStart(fn) {
            this.store.onComponentDragStart = fn;
        }
    }]);

    return ApplicationAction;
}();

__decorate([dob_1.inject(store_2.default), __metadata("design:type", store_2.default)], ApplicationAction.prototype, "store", void 0);
__decorate([dob_1.inject(store_1.default), __metadata("design:type", store_1.default)], ApplicationAction.prototype, "viewportStore", void 0);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "addPlugin", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "loadPluginByPosition", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "addComponentClass", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setComponentSetting", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setComponentDefaultProps", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "getComponentClassByKey", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setPreview", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setLeftTool", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setRightTool", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object, Function]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "createModal", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "closeModal", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "renderModalContent", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "createNewPageKey", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "createNewPage", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "createHomePage", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setCurrentEditPageKey", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "RemoveCreatingPage", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "removePage", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "changePageName", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "changePagePath", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "changePageParentKey", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "confirmCreatePage", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "getPageAllChilds", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "changeCurrentViewportPageKey", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "initApplication", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "resetApplication", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", Object)], ApplicationAction.prototype, "getAllInformation", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "getFullInformationGzipped", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setPreComponent", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "getSettingByInstance", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setPersistenceData", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "getPersistenceData", null);
__decorate([dob_1.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ApplicationAction.prototype, "setOnComponentDragStart", null);
exports.default = ApplicationAction;
//# sourceMappingURL=action.js.map