"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

Object.defineProperty(exports, "__esModule", { value: true });
var dependency_inject_1 = require("dependency-inject");
var action_1 = require("./application/action");
var store_1 = require("./application/store");
var action_2 = require("./event/action");
var store_2 = require("./event/store");
var action_3 = require("./viewport/action");
var store_3 = require("./viewport/store");

var StoreProps = function StoreProps() {
    _classCallCheck(this, StoreProps);
};

exports.StoreProps = StoreProps;

var Store = function () {
    function Store() {
        var _this = this;

        _classCallCheck(this, Store);

        this.container = new dependency_inject_1.Container();
        this.actions = {};
        this.stores = {};
        this.allActions = new Map();
        this.allStores = new Map();
        this.container = new dependency_inject_1.Container();
        this.allActions.set("ApplicationAction", action_1.default);
        this.allStores.set("ApplicationStore", store_1.default);
        this.allActions.set("ViewportAction", action_3.default);
        this.allStores.set("ViewportStore", store_3.default);
        this.allActions.set("EventAction", action_2.default);
        this.allStores.set("EventStore", store_2.default);
        this.allActions.forEach(function (actionClass, actionName) {
            _this.container.set(actionClass, new actionClass());
        });
        this.allStores.forEach(function (storeClass, storeName) {
            _this.container.set(storeClass, new storeClass());
        });
    }

    _createClass(Store, [{
        key: "addActions",
        value: function addActions(actions) {
            var _this2 = this;

            Object.keys(actions).forEach(function (key) {
                _this2.container.set(actions[key], new actions[key]());
                _this2.allActions.set(key, actions[key]);
            });
        }
    }, {
        key: "addStores",
        value: function addStores(stores) {
            var _this3 = this;

            Object.keys(stores).forEach(function (key) {
                _this3.container.set(stores[key], new stores[key]());
                _this3.allStores.set(key, stores[key]);
            });
        }
    }, {
        key: "getStore",
        value: function getStore() {
            var _this4 = this;

            this.allActions.forEach(function (actionClass, actionName) {
                _this4.actions[actionName] = _this4.container.get(actionClass);
            });
            this.allStores.forEach(function (storeClass, storeName) {
                _this4.stores[storeName] = _this4.container.get(storeClass);
            });
            return {
                actions: this.actions,
                stores: this.stores
            };
        }
    }]);

    return Store;
}();

exports.Store = Store;
//# sourceMappingURL=index.js.map