"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = undefined && undefined.__metadata || function (k, v) {
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_1 = require("dob");
var dob_2 = require("dob");
var _ = require("lodash");
var Sortable = require("sortablejs");
var action_1 = require("../application/action");
var store_1 = require("../application/store");
var action_2 = require("../event/action");
var store_2 = require("../event/store");
var store_3 = require("./store");

var ViewportAction = function () {
    function ViewportAction() {
        _classCallCheck(this, ViewportAction);
    }

    _createClass(ViewportAction, [{
        key: "setViewportDOM",
        value: function setViewportDOM(dom) {
            this.store.viewportDOM = dom;
        }
    }, {
        key: "createNewInstanceKey",
        value: function createNewInstanceKey() {
            return _.uniqueId("gaea_instance_");
        }
    }, {
        key: "setRootInstanceKey",
        value: function setRootInstanceKey(key) {
            this.store.rootInstanceKey = key;
        }
    }, {
        key: "addInstance",
        value: function addInstance(params) {
            var newInstanceKey = this.createNewInstanceKey();
            this.store.instances.set(newInstanceKey, {
                gaeaKey: params.gaeaKey,
                data: {
                    props: params.props
                },
                childs: [],
                parentInstanceKey: params.parentInstanceKey,
                preGaeaKey: params.preGaeaKey
            });
            if (params.parentInstanceKey !== null) {
                var parentInstance = this.store.instances.get(params.parentInstanceKey);
                parentInstance.childs.splice(params.indexPosition, 0, newInstanceKey);
                if (parentInstance.gaeaKey === "gaea-container" && params.gaeaKey === "gaea-container") {
                    if (this.getInstanceProps(params.parentInstanceKey, "style.display") === "flex" && this.getInstanceProps(newInstanceKey, "style.display") === "flex") {
                        switch (this.getInstanceProps(params.parentInstanceKey, "style.flexDirection")) {
                            case "column":
                                this.setInstanceProps(newInstanceKey, "style.flexDirection", "row");
                                break;
                            case "row":
                            default:
                                this.setInstanceProps(newInstanceKey, "style.flexDirection", "column");
                        }
                    }
                }
            }
            return newInstanceKey;
        }
    }, {
        key: "moveInstance",
        value: function moveInstance(sourceTargetKey, targetParentKey, targetIndex) {
            var sourceTargetInstance = this.store.instances.get(sourceTargetKey);
            var sourceParentInstance = this.store.instances.get(sourceTargetInstance.parentInstanceKey);
            var targetParentInstance = this.store.instances.get(targetParentKey);
            if (sourceTargetInstance.parentInstanceKey !== targetParentKey) {
                sourceTargetInstance.parentInstanceKey = targetParentKey;
                targetParentInstance.childs.splice(targetIndex, 0, sourceTargetKey);
                sourceParentInstance.childs = sourceParentInstance.childs.filter(function (childKey) {
                    return childKey !== sourceTargetKey;
                });
            } else {
                this.horizontalMoveInstance(targetParentKey, sourceParentInstance.childs.findIndex(function (childKey) {
                    return childKey === sourceTargetKey;
                }), targetIndex);
            }
        }
    }, {
        key: "horizontalMoveInstance",
        value: function horizontalMoveInstance(parentKey, beforeIndex, afterIndex) {
            var parentInstance = this.store.instances.get(parentKey);
            if (beforeIndex < afterIndex) {
                for (var index = beforeIndex; index < afterIndex; index++) {
                    var beforeUniqueKey = parentInstance.childs[index];
                    var afterUniqueKey = parentInstance.childs[index + 1];
                    parentInstance.childs[index] = afterUniqueKey;
                    parentInstance.childs[index + 1] = beforeUniqueKey;
                }
            } else {
                for (var _index = beforeIndex; _index > afterIndex; _index--) {
                    var _beforeUniqueKey = parentInstance.childs[_index];
                    var _afterUniqueKey = parentInstance.childs[_index - 1];
                    parentInstance.childs[_index] = _afterUniqueKey;
                    parentInstance.childs[_index - 1] = _beforeUniqueKey;
                }
            }
        }
    }, {
        key: "removeInstance",
        value: function removeInstance(reomveInstanceKey) {
            var _this = this;

            var removeInstance = this.store.instances.get(reomveInstanceKey);
            if (removeInstance.parentInstanceKey === null) {
                throw Error("不能删除根节点");
            }
            var childKeys = this.getAllChilds(reomveInstanceKey);
            childKeys.forEach(function (childKey) {
                _this.store.instances.delete(childKey);
            });
            var parentInstance = this.store.instances.get(removeInstance.parentInstanceKey);
            parentInstance.childs = parentInstance.childs.filter(function (childKey) {
                return childKey !== reomveInstanceKey;
            });
            this.store.instances.delete(reomveInstanceKey);
            if (reomveInstanceKey === this.store.currentEditInstanceKey) {
                this.setCurrentEditInstanceKey(null);
            }
            if (reomveInstanceKey === this.store.currentHoverInstanceKey) {
                this.setCurrentHoverInstanceKey(null);
            }
        }
    }, {
        key: "setInstanceProps",
        value: function setInstanceProps(instanceKey, key, value) {
            var instance = this.store.instances.get(instanceKey);
            var instanceClass = this.applicationStore.componentClasses.get(instance.gaeaKey);
            var defaultProps = this.applicationAction.getDefaultPropsByInstance(instance);
            if (value === _.get(defaultProps, key)) {
                delete instance.data.props[key];
                this.eventAction.emit(this.eventStore.instanceUpdate + "." + instanceKey);
                return;
            }
            _.set(instance.data, "props." + key, value);
            this.eventAction.emit(this.eventStore.instanceUpdate + "." + instanceKey);
        }
    }, {
        key: "setInstanceEvent",
        value: function setInstanceEvent(instanceKey, key, value) {
            var instance = this.store.instances.get(instanceKey);
            var instanceClass = this.applicationStore.componentClasses.get(instance.gaeaKey);
            _.set(instance.data, "events." + key, value);
        }
    }, {
        key: "getInstanceProps",
        value: function getInstanceProps(instanceKey, key) {
            var instance = this.store.instances.get(instanceKey);
            var instanceClass = this.applicationStore.componentClasses.get(instance.gaeaKey);
            var defaultProps = this.applicationAction.getDefaultPropsByInstance(instance);
            var dataResult = _.get(instance.data, "props." + key);
            if (dataResult === undefined) {
                return _.get(defaultProps, key);
            } else {
                return dataResult;
            }
        }
    }, {
        key: "getAllChilds",
        value: function getAllChilds(instanceKey) {
            var _this2 = this;

            var instance = this.store.instances.get(instanceKey);
            var childKeys = instance.childs || [];
            if (instance.childs) {
                instance.childs.forEach(function (childKey) {
                    var childNestMapUniqueKeys = _this2.getAllChilds(childKey);
                    if (childNestMapUniqueKeys.length > 0) {
                        var _childKeys;

                        childKeys = (_childKeys = childKeys).concat.apply(_childKeys, _toConsumableArray(childNestMapUniqueKeys));
                    }
                });
            }
            return childKeys;
        }
    }, {
        key: "setCurrentHoverInstanceKey",
        value: function setCurrentHoverInstanceKey(instanceKey) {
            this.store.currentHoverInstanceKey = instanceKey;
        }
    }, {
        key: "setCurrentEditInstanceKey",
        value: function setCurrentEditInstanceKey(instanceKey) {
            if (this.store.currentEditInstanceKey === instanceKey) {
                return;
            }
            this.store.currentEditInstanceKey = instanceKey;
        }
    }, {
        key: "startDrag",
        value: function startDrag(dragInfo) {
            this.store.currentDragInfo = dragInfo;
        }
    }, {
        key: "endDrag",
        value: function endDrag() {
            this.store.currentDragInfo = null;
        }
    }, {
        key: "setDragInfo",
        value: function setDragInfo(mapUniqueKey, index) {
            var newInfo = this.store.currentDragInfo.info;
            newInfo.targetInstanceKey = mapUniqueKey;
            newInfo.targetIndex = index;
        }
    }, {
        key: "getInstancePath",
        value: function getInstancePath(instanceKey) {
            var finderPath = [this.store.currentEditInstanceKey];
            if (this.store.currentEditInstanceKey === null) {
                return [];
            }
            var instance = this.store.instances.get(this.store.currentEditInstanceKey);
            if (instance.parentInstanceKey === null) {
                return [this.store.rootInstanceKey];
            }
            while (this.store.instances.get(instance.parentInstanceKey).parentInstanceKey !== null) {
                finderPath.unshift(instance.parentInstanceKey);
                instance = this.store.instances.get(instance.parentInstanceKey);
            }
            finderPath.unshift(this.store.rootInstanceKey);
            return finderPath;
        }
    }, {
        key: "setDomInstance",
        value: function setDomInstance(instanceKey, dom) {
            this.store.instanceDoms.set(instanceKey, dom);
        }
    }, {
        key: "resetViewport",
        value: function resetViewport(fullInformation) {
            var _this3 = this;

            this.clearViewport();
            Object.keys(fullInformation).forEach(function (instanceKey) {
                var instanceInfo = fullInformation[instanceKey];
                if (instanceInfo.parentInstanceKey === null) {
                    _this3.setRootInstanceKey(instanceKey);
                }
                _this3.store.instances.set(instanceKey, Object.assign({}, instanceInfo));
            });
        }
    }, {
        key: "initViewport",
        value: function initViewport() {
            var RootClass = this.applicationAction.getComponentClassByKey("gaea-container");
            var rootInstanceKey = this.addInstance({
                gaeaKey: "gaea-container",
                parentInstanceKey: null,
                indexPosition: null
            });
            this.setRootInstanceKey(rootInstanceKey);
            this.setInstanceProps(rootInstanceKey, "style", {
                display: "block",
                flexGrow: 1
            });
            if (this.applicationStore.pages.size === 0) {
                var homePageKey = this.applicationAction.createHomePage();
                this.applicationAction.changeCurrentViewportPageKey(homePageKey);
            }
        }
    }, {
        key: "clearViewport",
        value: function clearViewport() {
            this.store.instanceDoms.clear();
            this.store.instances.clear();
            this.store.rootInstanceKey = null;
            this.store.currentDragInfo = null;
            this.store.currentHoverInstanceKey = null;
            this.store.currentEditInstanceKey = null;
        }
    }, {
        key: "getSiblingInstances",
        value: function getSiblingInstances(instanceKey) {
            var _this4 = this;

            var instance = this.store.instances.get(instanceKey);
            if (instance.parentInstanceKey === null) {
                return [];
            }
            var parentInfo = this.store.instances.get(instance.parentInstanceKey);
            return parentInfo.childs.map(function (childInstanceKey) {
                return _this4.store.instances.get(childInstanceKey);
            });
        }
    }, {
        key: "registerInnerDrag",
        value: function registerInnerDrag(parentInstanceKey, dragParentDom, params) {
            var _this5 = this;

            var groupName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "gaea-container";

            var instance = this.store.instances.get(parentInstanceKey);
            Sortable.create(dragParentDom, Object.assign({}, params, { animation: 50, group: {
                    name: groupName,
                    pull: true,
                    put: true
                }, onStart: function onStart(event) {
                    _this5.startDrag({
                        type: "viewport",
                        dragStartParentDom: dragParentDom,
                        dragStartIndex: event.oldIndex,
                        info: {
                            instanceKey: instance.childs[event.oldIndex]
                        }
                    });
                }, onEnd: function onEnd(event) {
                    _this5.endDrag();
                    _this5.setCurrentHoverInstanceKey(null);
                }, onAdd: function onAdd(event) {
                    if (!_this5.store.dragStartDataReady) {
                        return;
                    }
                    switch (_this5.store.currentDragInfo.type) {
                        case "new":
                            var newInfo = _this5.store.currentDragInfo.info;
                            var newInstanceKey = _this5.addInstance({
                                gaeaKey: newInfo.gaeaKey,
                                parentInstanceKey: parentInstanceKey,
                                indexPosition: event.newIndex,
                                props: newInfo.props && JSON.parse(newInfo.props),
                                preGaeaKey: newInfo.preGaeaKey
                            });
                            break;
                        case "viewport":
                            if (_this5.store.currentDragInfo.dragStartParentDom.childNodes.length === 0) {
                                _this5.store.currentDragInfo.dragStartParentDom.appendChild(event.item);
                            } else if (_this5.store.currentDragInfo.dragStartParentDom.childNodes.length === _this5.store.currentDragInfo.dragStartIndex) {
                                _this5.store.currentDragInfo.dragStartParentDom.appendChild(event.item);
                            } else {
                                _this5.store.currentDragInfo.dragStartParentDom.insertBefore(event.item, _this5.store.currentDragInfo.dragStartParentDom.childNodes[_this5.store.currentDragInfo.dragStartIndex]);
                            }
                            _this5.setDragInfo(parentInstanceKey, event.newIndex);
                            break;
                        case "combo":
                            break;
                    }
                }, onUpdate: function onUpdate(event) {
                    var oldIndex = event.oldIndex;
                    var newIndex = event.newIndex;
                    if (_this5.store.currentDragInfo.dragStartParentDom.childNodes.length === oldIndex + 1) {
                        _this5.store.currentDragInfo.dragStartParentDom.appendChild(event.item);
                    } else {
                        if (newIndex > oldIndex) {
                            _this5.store.currentDragInfo.dragStartParentDom.insertBefore(event.item, _this5.store.currentDragInfo.dragStartParentDom.childNodes[oldIndex]);
                        } else {
                            _this5.store.currentDragInfo.dragStartParentDom.insertBefore(event.item, _this5.store.currentDragInfo.dragStartParentDom.childNodes[oldIndex + 1]);
                        }
                    }
                    _this5.horizontalMoveInstance(parentInstanceKey, event.oldIndex, event.newIndex);
                }, onRemove: function onRemove(event) {
                    var dragTargetKey = _this5.store.instances.get(parentInstanceKey).childs[_this5.store.currentDragInfo.dragStartIndex];
                    var dragViewportInfo = _this5.store.currentDragInfo.info;
                    _this5.moveInstance(dragTargetKey, dragViewportInfo.targetInstanceKey, dragViewportInfo.targetIndex);
                } }));
        }
    }, {
        key: "registerOuterDrag",
        value: function registerOuterDrag(dragParentDom) {
            var _this6 = this;

            var lastDragStartIndex = -1;
            Sortable.create(dragParentDom, {
                animation: 50,
                group: {
                    name: "gaea-container",
                    pull: "clone",
                    put: false
                },
                sort: false,
                delay: 0,
                onStart: function onStart(event) {
                    lastDragStartIndex = event.oldIndex;
                    if (event.item.dataset.source) {} else if (event.item.dataset.gaeaKey) {
                        if (_this6.applicationStore.onComponentDragStart !== null) {
                            _this6.store.dragStartDataReady = false;
                            var gaeaKey = event.item.dataset.preGaeaKey || event.item.dataset.gaeaKey;
                            Promise.resolve(_this6.applicationStore.onComponentDragStart(gaeaKey)).then(function (propsData) {
                                if (!propsData) {
                                    return;
                                }
                                if (_typeof(propsData.props) === "object") {
                                    if (event.item.dataset.props) {
                                        propsData.props = Object.assign({}, propsData.props || {}, JSON.parse(event.item.dataset.props));
                                    }
                                    event.item.dataset.props = JSON.stringify(propsData.props);
                                }
                                if (_typeof(propsData.setting) === "object") {
                                    _this6.applicationAction.setComponentSetting(gaeaKey, propsData.setting);
                                }
                            }).catch().then(function () {
                                _this6.startDrag({
                                    type: "new",
                                    dragStartParentDom: dragParentDom,
                                    dragStartIndex: event.oldIndex,
                                    info: {
                                        gaeaKey: event.item.dataset.gaeaKey,
                                        props: event.item.dataset.props,
                                        preGaeaKey: event.item.dataset.preGaeaKey
                                    }
                                });
                                _this6.store.dragStartDataReady = true;
                            });
                        }
                    }
                },
                onEnd: function onEnd(event) {
                    _this6.endDrag();
                    if (event.clone.parentNode) {
                        dragParentDom.removeChild(event.clone);
                        if (lastDragStartIndex === dragParentDom.childNodes.length) {
                            dragParentDom.appendChild(event.item);
                        } else {
                            dragParentDom.insertBefore(event.item, dragParentDom.childNodes[lastDragStartIndex]);
                        }
                    } else {}
                }
            });
        }
    }, {
        key: "instanceAddEvent",
        value: function instanceAddEvent(instanceKey) {
            var instance = this.store.instances.get(instanceKey);
            if (!instance) {
                throw Error("instanceKey: " + instanceKey + " \u4E0D\u5B58\u5728");
            }
            if (!instance.data.events) {
                instance.data.events = [];
            }
            instance.data.events.push({
                trigger: "init",
                action: "none"
            });
        }
    }, {
        key: "instanceRemoveEvent",
        value: function instanceRemoveEvent(instanceKey, index) {
            var instance = this.store.instances.get(instanceKey);
            if (!instance) {
                throw Error("instanceKey: " + instanceKey + " \u4E0D\u5B58\u5728");
            }
            instance.data.events.splice(index, 1);
        }
    }, {
        key: "instanceSetEvent",
        value: function instanceSetEvent(instanceKey, index, event) {
            var instance = this.store.instances.get(instanceKey);
            if (!instance) {
                throw Error("instanceKey: " + instanceKey + " \u4E0D\u5B58\u5728");
            }
            if (!instance.data.events || !instance.data.events[index]) {
                throw Error("instanceKey: " + instanceKey + " \u7684\u7B2C " + index + " \u4E2A\u4E8B\u4EF6\u4E0D\u5B58\u5728");
            }
            instance.data.events[index] = event;
        }
    }, {
        key: "eventGetSiblingParam",
        value: function eventGetSiblingParam(event) {
            if (event.action !== "passingSiblingNodes") {
                return null;
            }
            switch (event.trigger) {
                case "callback":
                    return event.actionData.data.map(function (data) {
                        return data.name;
                    });
            }
            return null;
        }
    }, {
        key: "instanceFieldIsVariable",
        value: function instanceFieldIsVariable(instanceKey, realField) {
            var instance = this.store.instances.get(instanceKey);
            if (instance.variables && Object.keys(instance.variables).some(function (key) {
                return key === realField;
            })) {
                return true;
            }
            return false;
        }
    }, {
        key: "instanceEnableVariable",
        value: function instanceEnableVariable(instanceKey, realField) {
            var instance = this.store.instances.get(instanceKey);
            if (!instance.variables) {
                instance.variables = {};
            }
            instance.variables[realField] = null;
        }
    }, {
        key: "instanceDisableVariable",
        value: function instanceDisableVariable(instanceKey, realField) {
            var instance = this.store.instances.get(instanceKey);
            if (instance.variables && Object.keys(instance.variables).some(function (key) {
                return key === realField;
            })) {
                delete instance.variables[realField];
            }
        }
    }, {
        key: "instanceSetVariable",
        value: function instanceSetVariable(instanceKey, realField, value) {
            var instance = this.store.instances.get(instanceKey);
            instance.variables[realField] = value;
        }
    }]);

    return ViewportAction;
}();

__decorate([dob_1.inject(store_3.default), __metadata("design:type", store_3.default)], ViewportAction.prototype, "store", void 0);
__decorate([dob_1.inject(store_1.default), __metadata("design:type", store_1.default)], ViewportAction.prototype, "applicationStore", void 0);
__decorate([dob_1.inject(action_1.default), __metadata("design:type", action_1.default)], ViewportAction.prototype, "applicationAction", void 0);
__decorate([dob_1.inject(action_2.default), __metadata("design:type", action_2.default)], ViewportAction.prototype, "eventAction", void 0);
__decorate([dob_1.inject(store_2.default), __metadata("design:type", store_2.default)], ViewportAction.prototype, "eventStore", void 0);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [HTMLElement]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setViewportDOM", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ViewportAction.prototype, "createNewInstanceKey", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setRootInstanceKey", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "addInstance", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String, Number]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "moveInstance", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Number, Number]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "horizontalMoveInstance", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "removeInstance", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String, Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setInstanceProps", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String, Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setInstanceEvent", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "getAllChilds", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setCurrentHoverInstanceKey", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setCurrentEditInstanceKey", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "startDrag", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ViewportAction.prototype, "endDrag", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Number]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setDragInfo", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "getInstancePath", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, HTMLElement]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "setDomInstance", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "resetViewport", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ViewportAction.prototype, "initViewport", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ViewportAction.prototype, "clearViewport", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "getSiblingInstances", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, HTMLElement, Object, Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "registerInnerDrag", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [HTMLElement]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "registerOuterDrag", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceAddEvent", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Number]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceRemoveEvent", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, Number, Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceSetEvent", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "eventGetSiblingParam", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceFieldIsVariable", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceEnableVariable", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceDisableVariable", null);
__decorate([dob_2.Action, __metadata("design:type", Function), __metadata("design:paramtypes", [String, String, Object]), __metadata("design:returntype", void 0)], ViewportAction.prototype, "instanceSetVariable", null);
exports.default = ViewportAction;
//# sourceMappingURL=action.js.map