"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var src_1 = require("../../../components/icon/src");
var isolated_type_1 = require("./isolated.type");
var S = require("./isolated.style");
var reg = function reg(input) {
    return new RegExp(input, 'g');
};

var Isolated = function (_React$PureComponent) {
    _inherits(Isolated, _React$PureComponent);

    function Isolated() {
        _classCallCheck(this, Isolated);

        var _this = _possibleConstructorReturn(this, (Isolated.__proto__ || Object.getPrototypeOf(Isolated)).apply(this, arguments));

        _this.state = new isolated_type_1.State();
        _this.handleToggleActionDetail = function (debugId) {
            if (debugId !== _this.props.debugInfo.id) {
                return;
            }
            _this.toggleDetail();
        };
        _this.handleFocusActionDetail = function (debugId) {
            if (debugId !== _this.props.debugInfo.id) {
                return;
            }
            _this.setState({
                isHighlight: true
            });
        };
        _this.handleUnFocusActionDetail = function (debugId) {
            if (debugId !== _this.props.debugInfo.id) {
                return;
            }
            _this.setState({
                isHighlight: false
            });
        };
        _this.toggleDetail = function () {
            _this.setState(function (state) {
                return {
                    showDetail: !_this.state.showDetail
                };
            });
        };
        _this.renderDetails = function (action, deep, key) {
            return action.changeList.map(function (change, index) {
                var newKey = key + '.' + index;
                switch (change.type) {
                    case 'change':
                        var newValue = JSON.stringify(change.value, null, 2);
                        var oldValue = JSON.stringify(change.oldValue, null, 2);
                        return React.createElement(S.ChangeContainer, { key: newKey }, React.createElement(S.ChangeBox, null, React.createElement(S.ChangeDetailContainer, null, React.createElement(S.ChangeTypeNewValue, null, newValue), React.createElement(S.ChangeTypeOldValue, { title: oldValue }, oldValue))), React.createElement(S.CallStack, null, React.createElement(S.CallStackPrefixKey, null, change.callStack.join('.'), "."), React.createElement(S.CallStackModifyKey, null, change.key)));
                    case 'delete':
                        return React.createElement(S.ChangeContainer, { key: newKey }, React.createElement(S.CallStackDeleted, null, React.createElement(S.CallStackPrefixKey, null, change.callStack.join('.'), "."), React.createElement(S.CallStackModifyKey, null, change.key)));
                    default:
                        return null;
                }
            });
        };
        return _this;
    }

    _createClass(Isolated, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            if (this.props.dyDebug) {
                this.props.dyDebug.event.on('toggleActionDetail', this.handleToggleActionDetail);
                this.props.dyDebug.event.on('focusActionDetail', this.handleFocusActionDetail);
                this.props.dyDebug.event.on('unFocusActionDetail', this.handleUnFocusActionDetail);
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            if (this.props.dyDebug) {
                this.props.dyDebug.event.off('toggleActionDetail', this.handleToggleActionDetail);
                this.props.dyDebug.event.off('focusActionDetail', this.handleFocusActionDetail);
                this.props.dyDebug.event.off('unFocusActionDetail', this.handleUnFocusActionDetail);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            if (this.props.deep === 0 && this.props.searchValue !== "" && !reg(this.props.searchValue).test(this.props.debugInfo.name)) {
                return null;
            }
            return React.createElement(S.Container, { theme: { deep: this.props.deep }, onClick: this.props.onClick, onMouseEnter: this.props.onMouseEnter, onMouseLeave: this.props.onMouseLeave }, React.createElement(S.Title, { theme: { highlight: this.state.isHighlight }, onClick: this.toggleDetail, onMouseEnter: function onMouseEnter() {
                    if (_this2.props.dyDebug) {
                        _this2.props.dyDebug.event.emit('focusDebug', _this2.props.debugInfo.id);
                    }
                }, onMouseLeave: function onMouseLeave() {
                    if (_this2.props.dyDebug) {
                        _this2.props.dyDebug.event.emit('unFocusDebug', _this2.props.debugInfo.id);
                    }
                } }, React.createElement(src_1.default, { size: 12, type: "scatter" })), this.state.showDetail && this.renderDetails(this.props.debugInfo, this.props.deep, this.props.renderKey));
        }
    }]);

    return Isolated;
}(React.PureComponent);

Isolated.defaultProps = new isolated_type_1.Props();
exports.Isolated = Isolated;
//# sourceMappingURL=isolated.component.js.map