"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var dob_1 = require("dob");
var dob_react_1 = require("dob-react");
var PropTypes = require("prop-types");
var tool_box_type_1 = require("./tool-box.type");
var S = require("./tool-box.style");
var isomorphic_1 = require("../utils/isomorphic");
var debug_line_component_1 = require("./debug-line/debug-line.component");
var scroll_to_1 = require("../utils/scroll-to");
var debounce = require("lodash.debounce");
var src_1 = require("../components/icon/src");

var ToolBox = function (_React$PureComponent) {
    _inherits(ToolBox, _React$PureComponent);

    function ToolBox() {
        _classCallCheck(this, ToolBox);

        var _this = _possibleConstructorReturn(this, (ToolBox.__proto__ || Object.getPrototypeOf(ToolBox)).apply(this, arguments));

        _this.state = new tool_box_type_1.State();
        _this.actionContainerDOM = null;
        _this.renderControlButton = function () {
            return React.createElement(S.ControlContainer, { theme: { showToolBox: _this.state.showToolBox } }, React.createElement(S.DisplayButton, { onClick: function onClick() {
                    _this.setState({
                        showToolBox: !_this.state.showToolBox
                    });
                } }, _this.state.showToolBox ? React.createElement(src_1.default, { type: "arrow-right" }) : React.createElement(src_1.default, { type: "arrow-left" })), React.createElement(S.UseDebug, { onClick: function onClick() {
                    if (_this.state.useDebug) {
                        dob_react_1.stopDebug();
                    } else {
                        dob_react_1.startDebug();
                    }
                    _this.setState({
                        useDebug: !_this.state.useDebug
                    });
                } }, _this.state.useDebug ? React.createElement(src_1.default, { type: "light-bulb-on" }) : React.createElement(src_1.default, { type: "light-bulb-off" })));
        };
        _this.getDebugInfoArray = function () {
            return Array.from(_this.context.dyDebug.debugInfoMap.values()).sort(function (left, right) {
                return right.id - left.id;
            });
        };
        _this.handleFocusActionDetail = function (debugId) {
            if (!_this.actionContainerDOM) {
                return;
            }
            var debugInfos = _this.getDebugInfoArray();
            var debugIndex = debugInfos.findIndex(function (debugInfo) {
                return debugInfo.id === debugId;
            });
            if (debugIndex === -1) {
                return;
            }
            var childDOM = _this.actionContainerDOM.firstChild.childNodes[debugIndex];
            if (!childDOM) {
                return;
            }
            _this.scrollTopDebugItem(_this.actionContainerDOM, childDOM);
        };
        _this.scrollTopDebugItem = debounce(function (parentDOM, childDOM) {
            scroll_to_1.scrollTo(_this.actionContainerDOM, childDOM.offsetTop, 50);
        }, 60);
        _this.renderToolBox = function () {
            if (!_this.state.showToolBox) {
                return null;
            }
            var debugInfos = _this.getDebugInfoArray();
            var Debugs = debugInfos.map(function (debugInfo, index) {
                return React.createElement(debug_line_component_1.DebugLine, { key: debugInfo.id, searchValue: _this.state.searchValue, debugInfo: debugInfo, dyDebug: _this.context.dyDebug });
            });
            return React.createElement(S.ToolContainer, null, React.createElement(S.HelperContainer, null, React.createElement(S.HelperInput, { onChange: function onChange(event) {
                    _this.setState({
                        searchValue: event.currentTarget.value
                    });
                }, placeholder: "搜索 action.." }), React.createElement(S.HelperButton, { onClick: _this.handleClear }, "\u6E05\u7A7A")), React.createElement(S.ToolScrollContainer, { ref: function ref(_ref) {
                    if (!_this.actionContainerDOM) {
                        _this.actionContainerDOM = ReactDOM.findDOMNode(_ref);
                    }
                } }, React.createElement(S.ActionContainer, null, Debugs)));
        };
        _this.handleClear = function () {
            _this.context.dyDebug.debugInfoMap.clear();
            setTimeout(function () {
                _this.forceUpdate();
            });
        };
        return _this;
    }

    _createClass(ToolBox, [{
        key: "componentWillMount",
        value: function componentWillMount() {
            var debugContainer = document.createElement("div");
            debugContainer.id = isomorphic_1.debugContainerId;
            debugContainer.style.position = 'absolute';
            debugContainer.style.top = '0px';
            debugContainer.style.right = '0px';
            debugContainer.style.bottom = '0px';
            debugContainer.style.left = '0px';
            debugContainer.style.pointerEvents = 'none';
            document.querySelector('body').appendChild(debugContainer);
        }
    }, {
        key: "getChildContext",
        value: function getChildContext() {
            return {
                dyDebug: this.context.dyDebug
            };
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var _this2 = this;

            dob_1.dobEvent.on('debug', function (debugInfo) {
                _this2.context.dyDebug.debugInfoMap.set(debugInfo.id, debugInfo);
                setTimeout(function () {
                    _this2.forceUpdate();
                });
            });
            this.context.dyDebug.event.on('focusActionDetail', this.handleFocusActionDetail);
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            this.context.dyDebug.event.on('focusActionDetail', this.handleFocusActionDetail);
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(S.Container, null, React.createElement(S.ChildrenContainer, null, this.props.children), this.renderToolBox(), this.renderControlButton());
        }
    }]);

    return ToolBox;
}(React.PureComponent);

ToolBox.defaultProps = new tool_box_type_1.Props();
ToolBox.contextTypes = {
    dyDebug: PropTypes.object
};
ToolBox.childContextTypes = {
    dyDebug: PropTypes.object
};
exports.ToolBox = ToolBox;
//# sourceMappingURL=tool-box.component.js.map